com.tibbo.aggregate.common.context

## Class AbstractContext<C extends Context>

- java.lang.Object
- - com.tibbo.aggregate.common.context.AbstractContext<C>

- All Implemented Interfaces:
    Context<C>, EvaluationPoint, java.lang.Comparable<C>
  Direct Known Subclasses:
    AgentContext, ProxyContext

      public abstract class AbstractContext<C extends Context>
      extends java.lang.Object
      implements Context<C>

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static TableFormat` | `ACTION_DEF_FORMAT`
    `static java.lang.String` | `CALLER_CONTROLLER_PROPERTY_DEBUG`
    `static java.lang.String` | `CALLER_CONTROLLER_PROPERTY_NO_CHANGE_EVENTS`
    `static java.lang.String` | `CALLER_CONTROLLER_PROPERTY_NO_STATISTICS`
    `static java.lang.String` | `CALLER_CONTROLLER_PROPERTY_NO_UPDATED_EVENTS`
    `static java.lang.String` | `CALLER_CONTROLLER_PROPERTY_NO_VALIDATION`
    `protected static java.lang.ThreadLocal<Pinpoint>` | `currentSource`
    `static int` | `DEFAULT_EVENT_LEVEL`
    `static java.lang.String` | `E_ACTION_ADDED`
    `static java.lang.String` | `E_ACTION_REMOVED`
    `static java.lang.String` | `E_ACTION_STATE_CHANGED`
    `static java.lang.String` | `E_CHANGE`
    `static java.lang.String` | `E_CHILD_ADDED`
    `static java.lang.String` | `E_CHILD_REMOVED`
    `static java.lang.String` | `E_DESTROYED`
    `static java.lang.String` | `E_EVENT_ADDED`
    `static java.lang.String` | `E_EVENT_REMOVED`
    `static java.lang.String` | `E_FUNCTION_ADDED`
    `static java.lang.String` | `E_FUNCTION_REMOVED`
    `static java.lang.String` | `E_INFO`
    `static java.lang.String` | `E_INFO_CHANGED`
    `static java.lang.String` | `E_UPDATED`
    `static java.lang.String` | `E_VARIABLE_ADDED`
    `static java.lang.String` | `E_VARIABLE_REMOVED`
    `static java.lang.String` | `E_VARIABLE_STATUS_CHANGED`
    `static EventDefinition` | `ED_ACTION_ADDED`
    `static EventDefinition` | `ED_ACTION_REMOVED`
    `static EventDefinition` | `ED_ACTION_STATE_CHANGED`
    `static EventDefinition` | `ED_CHANGE`
    `static EventDefinition` | `ED_CHILD_ADDED`
    `static EventDefinition` | `ED_CHILD_REMOVED`
    `static EventDefinition` | `ED_DESTROYED`
    `static EventDefinition` | `ED_EVENT_ADDED`
    `static EventDefinition` | `ED_EVENT_REMOVED`
    `static EventDefinition` | `ED_FUNCTION_ADDED`
    `static EventDefinition` | `ED_FUNCTION_REMOVED`
    `static EventDefinition` | `ED_INFO`
    `static EventDefinition` | `ED_INFO_CHANGED`
    `static EventDefinition` | `ED_UPDATED`
    `static EventDefinition` | `ED_VARIABLE_ADDED`
    `static EventDefinition` | `ED_VARIABLE_REMOVED`
    `static java.lang.String` | `EF_ACTION_REMOVED_NAME`
    `static TableFormat` | `EF_CHANGE`
    `static java.lang.String` | `EF_CHANGE_DATA`
    `static java.lang.String` | `EF_CHANGE_FORMAT`
    `static java.lang.String` | `EF_CHANGE_VALUE`
    `static java.lang.String` | `EF_CHANGE_VARIABLE`
    `static java.lang.String` | `EF_CHILD_ADDED_CHILD`
    `static java.lang.String` | `EF_CHILD_REMOVED_CHILD`
    `static TableFormat` | `EF_EVENT_ADDED`
    `static java.lang.String` | `EF_EVENT_REMOVED_NAME`
    `static TableFormat` | `EF_FUNCTION_ADDED`
    `static java.lang.String` | `EF_FUNCTION_REMOVED_NAME`
    `static java.lang.String` | `EF_INFO_INFO`
    `static TableFormat` | `EF_UPDATED`
    `static java.lang.String` | `EF_UPDATED_UPDATE_ORIGINATOR`
    `static java.lang.String` | `EF_UPDATED_USER`
    `static java.lang.String` | `EF_UPDATED_VALUE`
    `static java.lang.String` | `EF_UPDATED_VALUE_OLD`
    `static java.lang.String` | `EF_UPDATED_VARIABLE`
    `static java.lang.String` | `EF_UPDATED_VARIABLE_STATUS`
    `static java.lang.String` | `EF_VARIABLE_REMOVED_NAME`
    `static TableFormat` | `EFT_ACTION_REMOVED`
    `static TableFormat` | `EFT_CHILD_ADDED`
    `static TableFormat` | `EFT_CHILD_REMOVED`
    `static TableFormat` | `EFT_EVENT_REMOVED`
    `static TableFormat` | `EFT_FUNCTION_REMOVED`
    `static TableFormat` | `EFT_INFO`
    `static TableFormat` | `EFT_VARIABLE_REMOVED`
    `static TableFormat` | `EVENT_DEFINITION_FORMAT`
    `static int` | `EXECUTOR_THREADS_PERCENT_FOR_VISITORS`
    `static java.lang.String` | `F_BREAK_LOCK`
    `static java.lang.String` | `F_COPY`
    `static java.lang.String` | `F_COPY_TO_CHILDREN`
    `static java.lang.String` | `F_FIRE_CONTEXT_EVENT`
    `static java.lang.String` | `F_GET_ALIASES`
    `static java.lang.String` | `F_GET_COPY_DATA`
    `static java.lang.String` | `F_GET_VARIABLE_STATUS`
    `static java.lang.String` | `F_LOCK`
    `static java.lang.String` | `F_LOCKED_BY`
    `static java.lang.String` | `F_UNLOCK`
    `static java.lang.String` | `F_UPDATE_VARIABLE`
    `protected static FunctionDefinition` | `FD_COPY`
    `protected static FunctionDefinition` | `FD_COPY_TO_CHILDREN`
    `protected static FunctionDefinition` | `FD_FIRE_CONTEXT_EVENT`
    `protected static FunctionDefinition` | `FD_GET_ALIASES`
    `protected static FunctionDefinition` | `FD_GET_COPY_DATA`
    `protected static FunctionDefinition` | `FD_UPDATE_VARIABLE`
    `static java.lang.String` | `FIELD_ED_DESCRIPTION`
    `static java.lang.String` | `FIELD_ED_FORMAT`
    `static java.lang.String` | `FIELD_ED_GROUP`
    `static java.lang.String` | `FIELD_ED_HELP`
    `static java.lang.String` | `FIELD_ED_ICON_ID`
    `static java.lang.String` | `FIELD_ED_LEVEL`
    `static java.lang.String` | `FIELD_ED_NAME`
    `static java.lang.String` | `FIELD_FD_CONCURRENT`
    `static java.lang.String` | `FIELD_FD_DESCRIPTION`
    `static java.lang.String` | `FIELD_FD_GROUP`
    `static java.lang.String` | `FIELD_FD_HELP`
    `static java.lang.String` | `FIELD_FD_ICON_ID`
    `static java.lang.String` | `FIELD_FD_INPUTFORMAT`
    `static java.lang.String` | `FIELD_FD_NAME`
    `static java.lang.String` | `FIELD_FD_OUTPUTFORMAT`
    `static java.lang.String` | `FIELD_FD_PERMISSIONS`
    `static java.lang.String` | `FIELD_REPLICATE_ERRORS`
    `static java.lang.String` | `FIELD_REPLICATE_SUCCESSFUL`
    `static java.lang.String` | `FIELD_REPLICATE_VARIABLE`
    `static java.lang.String` | `FIELD_VD_ADD_PREVIOUS_VALUE_TO_VARIABLE_UPDATE_EVENT`
    `static java.lang.String` | `FIELD_VD_CACHE_TIME`
    `static java.lang.String` | `FIELD_VD_DESCRIPTION`
    `static java.lang.String` | `FIELD_VD_FORMAT`
    `static java.lang.String` | `FIELD_VD_GROUP`
    `static java.lang.String` | `FIELD_VD_HELP`
    `static java.lang.String` | `FIELD_VD_HELP_ID`
    `static java.lang.String` | `FIELD_VD_ICON_ID`
    `static java.lang.String` | `FIELD_VD_NAME`
    `static java.lang.String` | `FIELD_VD_READABLE`
    `static java.lang.String` | `FIELD_VD_SERVER_CACHING_MODE`
    `static java.lang.String` | `FIELD_VD_WRITABLE`
    `static java.lang.String` | `FIF_COPY_DATA_GROUP`
    `static java.lang.String` | `FIF_COPY_DATA_RECIPIENTS`
    `static java.lang.String` | `FIF_COPY_DATA_RECIPIENTS_RECIPIENT`
    `static java.lang.String` | `FIF_FIRE_EVENT_DATA`
    `static java.lang.String` | `FIF_FIRE_EVENT_EVENT`
    `static java.lang.String` | `FIF_FIRE_EVENT_LEVEL`
    `static java.lang.String` | `FIF_LOCK_PROPERTIES_EDITOR_UUID`
    `static java.lang.String` | `FIF_REPLICATE_FIELDS_DESCRIPTION`
    `static java.lang.String` | `FIF_REPLICATE_FIELDS_NAME`
    `static java.lang.String` | `FIF_REPLICATE_FIELDS_REPLICATE`
    `static java.lang.String` | `FIF_UNLOCK_PROPERTIES_EDITOR_UUID`
    `static java.lang.String` | `FIF_VISIBLE_CHILDREN_CONTEXT_MASK`
    `static java.lang.String` | `FIF_VISIBLE_CHILDREN_COUNT`
    `static java.lang.String` | `FIF_VISIBLE_CHILDREN_FILTER_EXPRESSION`
    `static java.lang.String` | `FIF_VISIBLE_CHILDREN_GLOBAL_FILTER`
    `static java.lang.String` | `FIF_VISIBLE_CHILDREN_OFFSET`
    `static java.lang.String` | `FIF_VISIBLE_CHILDREN_PROPERTY_FILTERS`
    `static java.lang.String` | `FIF_VISIBLE_CHILDREN_SMART_FILTER_EXPRESSION`
    `static TableFormat` | `FIFT_FIRE_CONTEXT_EVENT`
    `static TableFormat` | `FIFT_GET_COPY_DATA`
    `static TableFormat` | `FIFT_GET_COPY_DATA_RECIPIENTS`
    `static TableFormat` | `FIFT_GET_VARIABLE_STATUS`
    `static TableFormat` | `FIFT_LOCK`
    `static TableFormat` | `FIFT_REPLICATE_FIELDS`
    `static TableFormat` | `FIFT_UNLOCK`
    `static TableFormat` | `FIFT_UPDATE_VARIABLE`
    `static TableFormat` | `FIFT_VISIBLE_CHILDREN`
    `static java.lang.String` | `FOF_COPY_DATA_DESCRIPTION`
    `static java.lang.String` | `FOF_COPY_DATA_FIELDS`
    `static java.lang.String` | `FOF_COPY_DATA_NAME`
    `static java.lang.String` | `FOF_COPY_DATA_REPLICATE`
    `static java.lang.String` | `FOF_COPY_DATA_VALUE`
    `static java.lang.String` | `FOF_FIRE_EVENT_ID`
    `static java.lang.String` | `FOF_GET_ALIASES_ALIAS_NAME`
    `static java.lang.String` | `FOF_GET_ALIASES_ENTITY_TYPE`
    `static java.lang.String` | `FOF_GET_ALIASES_NAME`
    `static java.lang.String` | `FOF_LOCK_OWNER_NAME`
    `static java.lang.String` | `FOF_LOCKED_BY_OWNER_NAME`
    `static java.lang.String` | `FOF_UNLOCK_UNLOCKED`
    `static java.lang.String` | `FOF_VISIBLE_CHILDREN_BATCH`
    `static java.lang.String` | `FOF_VISIBLE_CHILDREN_TOTAL_COUNT`
    `static TableFormat` | `FOFT_FIRE_CONTEXT_EVENT`
    `static TableFormat` | `FOFT_GET_ALIASES`
    `static TableFormat` | `FOFT_LOCK`
    `static TableFormat` | `FOFT_LOCKED_BY`
    `static TableFormat` | `FOFT_UNLOCK`
    `static TableFormat` | `FOFT_VISIBLE_CHILDREN`
    `static TableFormat` | `FUNCTION_DEFINITION_FORMAT`
    `static int` | `INDEX_HIGH`
    `static int` | `INDEX_HIGHER`
    `static int` | `INDEX_HIGHEST`
    `static int` | `INDEX_LOW`
    `static int` | `INDEX_LOWER`
    `static int` | `INDEX_LOWEST`
    `static int` | `INDEX_NORMAL`
    `static int` | `INDEX_VERY_HIGH`
    `static int` | `INDEX_VERY_LOW`
    `static TableFormat` | `INFO_DEFINITION_FORMAT`
    `protected java.util.concurrent.CompletableFuture<C>` | `ready`
    `static TableFormat` | `REPLICATE_INPUT_FORMAT`
    `static TableFormat` | `REPLICATE_OUTPUT_FORMAT`
    `protected static TableFormat` | `REPLICATE_TO_CHILDREN_OUTPUT_FORMAT`
    `static TableFormat` | `RESOURCE_MASKS_FORMAT`
    `protected static int` | `SORT_THRESHOLD`
    `static java.lang.String` | `V_ACTIONS`
    `static java.lang.String` | `V_CHILDREN`
    `static java.lang.String` | `V_EVENTS`
    `static java.lang.String` | `V_FUNCTIONS`
    `static java.lang.String` | `V_INFO`
    `static java.lang.String` | `V_UPDATE_VARIABLE`
    `static java.lang.String` | `V_UPDATE_VARIABLE_EXPRESSION`
    `static java.lang.String` | `V_VARIABLE_NAME`
    `static java.lang.String` | `V_VARIABLE_STATUSES`
    `static java.lang.String` | `V_VARIABLES`
    `static TableFormat` | `VARIABLE_DEFINITION_FORMAT`
    `static VariableDefinition` | `VD_ACTIONS`
    `static VariableDefinition` | `VD_CHILDREN`
    `static VariableDefinition` | `VD_EVENTS`
    `static VariableDefinition` | `VD_FUNCTIONS`
    `static VariableDefinition` | `VD_INFO`
    `static VariableDefinition` | `VD_VARIABLES`
    `static java.lang.String` | `VF_CHILDREN_IS_CONTAINER`
    `static java.lang.String` | `VF_CHILDREN_NAME`
    `static java.lang.String` | `VF_INFO_DESCRIPTION`
    `static java.lang.String` | `VF_INFO_GROUP`
    `static java.lang.String` | `VF_INFO_ICON`
    `static java.lang.String` | `VF_INFO_LOCAL_ROOT`
    `static java.lang.String` | `VF_INFO_MAPPED`
    `static java.lang.String` | `VF_INFO_PEER_PRIMARY_ROOT`
    `static java.lang.String` | `VF_INFO_PEER_ROOT`
    `static java.lang.String` | `VF_INFO_REMOTE_PATH`
    `static java.lang.String` | `VF_INFO_REMOTE_ROOT`
    `static java.lang.String` | `VF_INFO_TYPE`
    `static java.lang.String` | `VF_VARIABLE_STATUSES_COMMENT`
    `static java.lang.String` | `VF_VARIABLE_STATUSES_NAME`
    `static java.lang.String` | `VF_VARIABLE_STATUSES_STATUS`
    `static java.lang.String` | `VF_VISIBLE_CHILDREN_PROPERTY_FILTERS_PROPERTY_NAME`
    `static java.lang.String` | `VF_VISIBLE_CHILDREN_PROPERTY_FILTERS_PROPERTY_VALUE`
    `protected static TableFormat` | `VFT_CHILDREN`
    `static TableFormat` | `VFT_VISIBLE_CHILDREN`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractContext(java.lang.String name)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `accept(ContextVisitor visitor)` Accepts context visitor, i.e. calls visitor.visit(this).
    `ActionDefinition` | `actDefFromDataRecord(DataRecord rec)`
    `DataRecord` | `actDefToDataRecord(ActionDefinition def)`
    `void` | `addActionDefinition(ActionDefinition def)` Add a new action definition to the context.
    `void` | `addAlias(int entityType, java.lang.String aliasName, java.lang.String name)`
    `void` | `addChild(C child)` Adds new child to the current context.
    `void` | `addChild(C child, DataTable childInfo)`
    `void` | `addChild(C child, java.lang.Integer index)`
    `void` | `addChild(C child, java.lang.Integer index, DataTable childInfo)`
    `void` | `addEventDefinition(EventDefinition def)` Adds event definition to this context.
    `boolean` | `addEventListener(java.lang.String name, ContextEventListener listener)` Adds listener of event with specified name.
    `boolean` | `addEventListener(java.lang.String name, ContextEventListener listener, boolean weak)` Adds listener of event with specified name.
    `void` | `addFunctionDefinition(FunctionDefinition def)` Adds function definition to this context.
    `void` | `addVariableDefinition(VariableDefinition def)` Adds variable definition to this context.
    `void` | `addVariableRecord(java.lang.String variable, CallerController cc, DataRecord record)`
    `void` | `addVariableRecord(java.lang.String variable, CallerController cc, java.lang.Object... recordData)`
    `protected void` | `applyCachedFormat(java.util.function.Supplier<TableFormat> formatGetter, java.util.function.Consumer<TableFormat> formatSetter)` Extracts table format with given getter and puts it into current format cache.
    `AbstractContext` | `awaitInitialized()`
    `DataTable` | `callFcopy(FunctionDefinition def, CallerController caller, RequestController request, DataTable parameters)`
    `DataTable` | `callFcopyToChildren(FunctionDefinition def, CallerController caller, RequestController request, DataTable parameters)`
    `DataTable` | `callFfireContextEvent(FunctionDefinition def, CallerController caller, RequestController request, DataTable parameters)`
    `DataTable` | `callFgetAliases(FunctionDefinition def, CallerController caller, RequestController request, DataTable parameters)`
    `DataTable` | `callFgetCopyData(FunctionDefinition def, CallerController caller, RequestController request, DataTable parameters)`
    `protected DataTable` | `callFunction(FunctionDefinition def, CallerController caller, RequestController request, DataTable parameters)`
    `DataTable` | `callFunction(java.lang.String name)` Executes context function with specified `parameters` and returns its output.
    `DataTable` | `callFunction(java.lang.String name, CallerController caller)` Executes context function with specified `parameters` and returns its output.
    `DataTable` | `callFunction(java.lang.String name, CallerController caller, DataTable parameters)` Executes context function with specified `parameters` and returns its output.
    `DataTable` | `callFunction(java.lang.String name, CallerController caller, java.lang.Object... parameters)` Executes context function with specified `parameters` and returns its output.
    `DataTable` | `callFunction(java.lang.String name, CallerController caller, RequestController request, DataTable parameters)` Executes context function with specified `parameters` and returns its output.
    `DataTable` | `callFunction(java.lang.String name, DataTable parameters)` Executes context function with specified `parameters` and returns its output.
    `DataTable` | `callFunction(java.lang.String name, java.lang.Object... parameters)` Executes context function with specified `parameters` and returns its output.
    `protected DataTable` | `callFunctionImpl(FunctionDefinition def, CallerController caller, RequestController request, DataTable parameters)`
    `DataTable` | `callFupdateVariable(FunctionDefinition def, CallerController caller, RequestController request, DataTable parameters)`
    `boolean` | `checkPermissions(Permissions needPermissions, CallerController caller, Context accessedContext, EntityDefinition accessedEntityDefinition)`
    `protected void` | `checkPermissions(Permissions needPermissions, CallerController caller, EntityDefinition accessedEntityDefinition)`
    `protected void` | `clearVariableStatuses()`
    `int` | `compareTo(Context context)`
    `protected DataTable` | `copyTo(FunctionDefinition def, CallerController caller, RequestController request, DataTable parameters, java.util.List<C> children)`
    `protected DataTable` | `createContextInfoTable()`
    `protected TableFormat` | `decodeFormat(java.lang.String source, CallerController caller)`
    `void` | `destroy(boolean moving)` Permanently destroys this context.
    `void` | `destroyChild(C child, boolean moving)` Permanently destroys child of current context.
    `protected void` | `destroyChildren(boolean moving)`
    `protected void` | `enableStatus()`
    `protected void` | `enableVariableStatuses(boolean persistent)`
    `protected java.lang.String` | `encodeFormat(TableFormat format, CallerController caller)`
    `protected void` | `ensureVariableStatuses()`
    `boolean` | `equals(java.lang.Object obj)`
    `EventDefinition` | `evtDefFromDataRecord(DataRecord rec)`
    `DataRecord` | `evtDefToDataRecord(EventDefinition ed)`
    `protected DataRecord` | `evtDefToDataRecord(EventDefinition ed, CallerController caller)`
    `DataTable` | `executeDefaultGetter(java.lang.String name, CallerController caller)`
    `DataTable` | `executeDefaultGetter(java.lang.String name, CallerController caller, boolean check)`
    `DataTable` | `executeDefaultGetter(java.lang.String name, CallerController caller, boolean check, boolean createDefault)`
    `protected DataTable` | `executeDefaultGetterImpl(VariableDefinition vd, CallerController caller)`
    `void` | `executeDefaultSetter(java.lang.String name, CallerController caller, DataTable value)`
    `void` | `executeDefaultSetter(VariableDefinition def, CallerController caller, DataTable value)`
    `protected void` | `executeDefaultSetterImpl(VariableDefinition vd, CallerController caller, DataTable value)`
    `protected void` | `executeTasks(java.util.List<java.util.concurrent.Callable<java.lang.Object>> tasks)`
    `protected void` | `executeTasks(java.util.List<java.util.concurrent.Callable<java.lang.Object>> tasks, double loadFactor)`
    `protected void` | `executeTasksConcurrently(java.util.List<java.util.concurrent.Callable<java.lang.Object>> tasks, double loadFactor)` Tries to utilize underlying `ContextOperationExecutor` as much as possible but without occupying 100% of its threads.
    `protected DataTable` | `fetchVariableStatuses()`
    `void` | `fireChangeEvent(VariableDefinition def, CallerController caller, java.util.Date timestamp, DataTable value)`
    `protected Event` | `fireEvent(Event event)`
    `protected Event` | `fireEvent(EventDefinition ed, DataTable data, int level, java.lang.Long id, java.util.Date creationtime, java.lang.Integer listener, CallerController caller, FireEventRequestController request, Permissions permissions)`
    `protected Event` | `fireEvent(EventDefinition ed, Event event, java.lang.Integer listener, CallerController caller, FireEventRequestController request)`
    `Event` | `fireEvent(java.lang.String name)` Fires context event.
    `Event` | `fireEvent(java.lang.String name, CallerController caller)` Fires context event.
    `Event` | `fireEvent(java.lang.String name, CallerController caller, DataTable data)` Fires context event.
    `Event` | `fireEvent(java.lang.String name, DataTable data)` Fires context event.
    `Event` | `fireEvent(java.lang.String name, DataTable data, int level, java.lang.Long id, java.util.Date creationtime, java.lang.Integer listener, CallerController caller, FireEventRequestController request)` Fires context event.
    `Event` | `fireEvent(java.lang.String name, FireEventRequestController request, java.lang.Object... data)`
    `Event` | `fireEvent(java.lang.String name, int level, CallerController caller, DataTable data)` Fires context event.
    `Event` | `fireEvent(java.lang.String name, int level, CallerController caller, FireEventRequestController request, DataTable data)` Fires context event.
    `Event` | `fireEvent(java.lang.String name, int level, CallerController caller, FireEventRequestController request, Permissions permissions, DataTable data)`
    `Event` | `fireEvent(java.lang.String name, int level, DataTable data)` Fires context event.
    `Event` | `fireEvent(java.lang.String name, java.lang.Object... data)` Fires context event.
    `protected void` | `fireEventAdded(EventDefinition def)`
    `protected void` | `fireFunctionAdded(FunctionDefinition def)`
    `protected void` | `fireStatusChanged(int status, java.lang.String comment, int oldStatus)`
    `protected void` | `fireUpdatedEvent(VariableDefinition def, CallerController caller, RequestController request, DataTable value, DataTable valueOld)`
    `protected void` | `fireVariableAdded(VariableDefinition def)`
    `FunctionDefinition` | `funcDefFromDataRecord(DataRecord rec)`
    `DataRecord` | `funcDefToDataRecord(FunctionDefinition fd)`
    `protected DataRecord` | `funcDefToDataRecord(FunctionDefinition fd, CallerController caller)`
    `C` | `get(java.lang.String contextName)` Returns context with the selected path.
    `C` | `get(java.lang.String contextPath, CallerController caller)` Returns context with the selected path.
    `ActionDefinition` | `getActionDefinition(java.lang.String name)` Returns action definition by name.
    `ActionDefinition` | `getActionDefinition(java.lang.String name, CallerController caller)` Returns action definition by name.
    `java.util.List<ActionDefinition>` | `getActionDefinitions()` Returns action definitions.
    `java.util.List<ActionDefinition>` | `getActionDefinitions(CallerController caller)` Returns action definitions that are accessible for the caller.
    `java.util.List<ActionDefinition>` | `getActionDefinitions(CallerController caller, boolean includeHidden)` Returns action definitions.
    `protected EventDefinition` | `getChangeEventDefinition()`
    `C` | `getChild(java.lang.String name)` Returns child of this context with the specified name.
    `C` | `getChild(java.lang.String name, CallerController caller)` Returns child of this context with the specified name.
    `java.util.List<C>` | `getChildren()` Returns list of children contexts.
    `java.util.List<C>` | `getChildren(CallerController caller)` Returns list of children contexts that are accessible by the specified `CallerController`.
    `protected java.util.concurrent.locks.ReentrantReadWriteLock` | `getChildrenLock()`
    `Permissions` | `getChildrenViewPermissions()` Returns permissions required to access children of this context.
    `ContextManager<C>` | `getContextManager()` Returns context manager those context tree contains this context.
    `ActionDefinition` | `getDefaultActionDefinition(CallerController caller)` Returns default action definition or NULL if there is no default action or it's not available to the caller.
    `DataTable` | `getDefaultValue(VariableDefinition def)`
    `java.lang.String` | `getDescription()` Returns context description.
    `EventData` | `getEventData(java.lang.String name)` Returns `EventData` of event with specified name.
    `protected java.util.Map<java.lang.String,EventData>` | `getEventDataView()`
    `EventDefinition` | `getEventDefinition(java.lang.String name)` Returns definition of event with specified name.
    `EventDefinition` | `getEventDefinition(java.lang.String name, CallerController caller)` Returns definition of event with specified name if it's accessible by caller controller.
    `java.util.List<EventDefinition>` | `getEventDefinitions()` Returns list of events.
    `java.util.List<EventDefinition>` | `getEventDefinitions(CallerController caller)` Returns list of events available for specified `CallerController`.
    `java.util.List<EventDefinition>` | `getEventDefinitions(CallerController caller, boolean includeHidden)` Returns list of events.
    `java.util.List<EventDefinition>` | `getEventDefinitions(CallerController caller, java.lang.String group)` Returns list of events belonging to `group` that are available for specified `CallerController`.
    `java.util.List<EventDefinition>` | `getEventDefinitions(java.lang.String group)` Returns list of events belonging to `group`.
    `java.util.List<Event>` | `getEventHistory(java.lang.String name)` Returns in-memory event history.
    `protected CallerController` | `getEventProcessingCallerController()`
    `protected EventProcessingRule` | `getEventProcessingRule(Event event)`
    `FunctionData` | `getFunctionData(java.lang.String name)` Returns data of function with specified name.
    `protected java.util.Map<java.lang.String,FunctionData>` | `getFunctionDataView()`
    `FunctionDefinition` | `getFunctionDefinition(java.lang.String name)` Returns definition of function with specified name.
    `FunctionDefinition` | `getFunctionDefinition(java.lang.String name, CallerController caller)` Returns definition of function with specified name if it's accessible by caller controller.
    `java.util.List<FunctionDefinition>` | `getFunctionDefinitions()` Returns list of functions.
    `java.util.List<FunctionDefinition>` | `getFunctionDefinitions(CallerController caller)` Returns list of functions available for specified `CallerController`.
    `java.util.List<FunctionDefinition>` | `getFunctionDefinitions(CallerController caller, boolean includeHidden)` Returns list of functions.
    `java.util.List<FunctionDefinition>` | `getFunctionDefinitions(CallerController caller, java.lang.String group)` Returns list of functions belonging to `group` that are available for specified `CallerController`.
    `java.util.List<FunctionDefinition>` | `getFunctionDefinitions(java.lang.String group)` Returns list of functions belonging to `group`.
    `java.lang.String` | `getGroup()` Returns context group name of NULL if context does not belong to a group.
    `java.lang.String` | `getIconId()` Returns context icon ID.
    `java.lang.Integer` | `getIndex()` Returns context comparison index or NULL if index is not defined.
    `java.lang.String` | `getLocalPrimaryRoot()` In distributed environment, returns path of the primary mount context in local tree.
    `java.lang.String` | `getLocalRoot(boolean withParent)` Returns path of the root context.
    `java.util.List<C>` | `getMappedChildren()` Returns list of mapped children contexts.
    `java.util.List<C>` | `getMappedChildren(CallerController caller)` Returns list of mapped children contexts.
    `java.lang.String` | `getName()` Returns context name.
    `C` | `getParent()` Returns parent of this context.
    `java.lang.String` | `getPath()` Returns context path (full name).
    `java.lang.String` | `getPeerPath()` In distributed environment, returns path of the context on the server immediately connected to current server (current server's peer).
    `java.lang.String` | `getPeerRoot()` When a certain context subtree from one server is connected to another server, this method will return the remote path of this subtree's root context.
    `PermissionChecker` | `getPermissionChecker()`
    `Permissions` | `getPermissions()` Returns context permissions.
    `java.lang.String` | `getRemotePath()` In distributed environment, returns path of the context on the server where it's actually defined.
    `java.lang.String` | `getRemoteRoot()` Returns path of remote server's root context within a distributed connection.
    `C` | `getRoot()` Returns root context of the context tree containing this context.
    `ContextStatus` | `getStatus()` Returns context status or null if status is not enabled;
    `java.lang.String` | `getType()` Returns context type.
    `DataTable` | `getVactions(VariableDefinition def, CallerController caller, RequestController request)`
    `DataTable` | `getVariable(java.lang.String name)` Gets variable from context and returns its value.
    `DataTable` | `getVariable(java.lang.String name, CallerController caller)` Gets variable from context and returns its value.
    `DataTable` | `getVariable(java.lang.String name, CallerController caller, RequestController request)` Gets variable from context and returns its value.
    `DataTable` | `getVariableClone(java.lang.String name, CallerController caller)` Gets variable from context and returns its value.
    `VariableData` | `getVariableData(java.lang.String name)` Returns data of variable with specified name.
    `protected java.util.Map<java.lang.String,VariableData>` | `getVariableDataView()`
    `VariableDefinition` | `getVariableDefinition(java.lang.String name)` Returns definition of variable with specified name.
    `VariableDefinition` | `getVariableDefinition(java.lang.String name, CallerController caller)` Returns definition of variable with specified name if it's accessible by caller controller.
    `java.util.List<VariableDefinition>` | `getVariableDefinitions()` Returns list of variables.
    `java.util.List<VariableDefinition>` | `getVariableDefinitions(CallerController caller)` Returns list of variables available for specified `CallerController`.
    `java.util.List<VariableDefinition>` | `getVariableDefinitions(CallerController caller, boolean includeHidden)` Returns list of variables.
    `java.util.List<VariableDefinition>` | `getVariableDefinitions(CallerController caller, java.lang.String group)` Returns list of variables belonging to `group` that are available for specified `CallerController`.
    `java.util.List<VariableDefinition>` | `getVariableDefinitions(java.lang.String group)` Returns list of variables belonging to `group`.
    `protected DataTable` | `getVariableImpl(VariableDefinition def, CallerController caller, RequestController request)`
    `java.lang.Object` | `getVariableObject(java.lang.String name, CallerController caller)` Returns value of variable as bean or list of beans.
    `VariableStatus` | `getVariableStatus(VariableDefinition variableDefinition)`
    `DataTable` | `getVchildren(VariableDefinition def, CallerController caller, RequestController request)`
    `DataTable` | `getVevents(VariableDefinition def, CallerController caller, RequestController request)`
    `DataTable` | `getVfunctions(VariableDefinition def, CallerController caller, RequestController request)`
    `DataTable` | `getVinfo(VariableDefinition def, CallerController caller, RequestController request)`
    `java.util.List<C>` | `getVisibleChildren()` Returns list of visible children contexts.
    `java.util.List<C>` | `getVisibleChildren(CallerController caller)` Returns list of visible children contexts.
    `DataTable` | `getVvariables(VariableDefinition def, CallerController caller, RequestController request)`
    `int` | `hashCode()`
    `boolean` | `hasMappedChild(java.lang.String contextName, CallerController callerController)` Check if the mapped child of this context is available.
    `boolean` | `hasParent(C parentContext)` Returns true if parentContext is a parent of this context or some of its parents.
    `boolean` | `hasVisibleChild(java.lang.String name, CallerController caller)` Check if the visible child of the context is available.
    `protected boolean` | `isAllowSetterExecution(VariableDefinition data, RequestController request, DataTable value)`
    `protected boolean` | `isAllowUpdatedEvents(VariableDefinition def)`
    `protected boolean` | `isBelongedToTheGroup(java.lang.String targetGroup, java.lang.String entityGroup)`
    `boolean` | `isChildrenConcurrencyEnabled()`
    `boolean` | `isChildrenSortingEnabled()`
    `boolean` | `isContainer()` Returns true if context is container.
    `boolean` | `isDebuggingEvaluations()`
    `boolean` | `isDistributed()` Returns true if context has a remote peer in the distributed architecture.
    `boolean` | `isEntityProtected(EntityDefinition ed)`
    `protected boolean` | `isFireUpdateEvents()`
    `boolean` | `isInitializedChildren()` This method should return true if the context has already been initialized its children.
    `boolean` | `isInitializedEvents()` This method should return true if the context has already been initialized its events.
    `boolean` | `isInitializedFunctions()` This method should return true if the context has already been initialized its functions.
    `boolean` | `isInitializedInfo()` This method should return true if the context has already been initialized its basic information (description, type, etc).
    `boolean` | `isInitializedStatus()` This method should return true if the context status has already been initialized.
    `boolean` | `isInitializedVariables()` This method should return true if the context has already been initialized its variables.
    `boolean` | `isInstallationAllowed(java.lang.String installableName)` Check if an installation is permitted.
    `boolean` | `isMapped()` Returns true if context's visible children are mapped (e.g. for group and aggregation contexts).
    `boolean` | `isPermissionCheckingEnabled()`
    `boolean` | `isProtected()`
    `boolean` | `isProxy()` Returns true if context is a remote context's proxy.
    `boolean` | `isSetupComplete()` This method should return true if the context has already been initialized and setupMyself() finished execution.
    `boolean` | `isStarted()` Returns true if context was started but not yet stopped.
    `boolean` | `isStopped()`
    `protected void` | `logAsyncSessionExecutionAction(CallerController caller, RequestController requestController, ContextOperationType operationType, java.lang.String entityName, DataTable parameters, DataTable output, long duration)`
    `void` | `move(C newParent, java.lang.String newName)` Moves and/or renames the context.
    `protected void` | `moveFinalize(java.lang.String oldPath, java.lang.String oldName, java.lang.String newPath, java.lang.String newName)`
    `protected void` | `moveInternal(java.lang.String oldPath, java.lang.String oldName, java.lang.String newPath, java.lang.String newName)`
    `protected void` | `movePrepare(java.lang.String oldPath, java.lang.String oldName, java.lang.String newPath, java.lang.String newName)`
    `protected java.util.Optional<FormatCache>` | `obtainFormatCache()`
    `protected void` | `onIllegalDefinitionUpdated(java.lang.String definitionName)`
    `protected void` | `persistVariableStatuses(DataTable statuses)`
    `protected void` | `postEvent(Event ev, EventDefinition ed, CallerController caller, FireEventRequestController request)`
    `protected void` | `processBindings(Event event)`
    `void` | `processEvaluation(Evaluator evaluator, Expression expression, Reference holder, java.lang.Object result, NodeEvaluationDetails details)`
    `void` | `processEvaluationError(Evaluator evaluator, Expression expression, Reference holder, java.lang.Exception error, NodeEvaluationDetails details)`
    `void` | `removeActionDefinition(java.lang.String name)` Remove an action definition from the context.
    `void` | `removeChild(C child)` Removes child of current context.
    `void` | `removeChild(java.lang.String name)` Removes child with specified name.
    `void` | `removeEventDefinition(java.lang.String name)` Removes event definition from this context.
    `boolean` | `removeEventListener(java.lang.String name, ContextEventListener listener)` Removes listener of event with specified name.
    `void` | `removeFromParent()`
    `void` | `removeFunctionDefinition(java.lang.String name)` Removes function definition from this context.
    `protected void` | `removeValues(VariableDefinition vd)`
    `void` | `removeVariableDefinition(java.lang.String name)` Removes variable definition from this context.
    `void` | `removeVariableRecords(java.lang.String variable, CallerController cc, java.lang.String field, java.lang.Object value)`
    `protected void` | `reorderChild(C child, int index)`
    `java.util.Set<java.lang.String>` | `replicateVariableOnCopy(java.lang.String variableName, DataTable variableValue, DataTable targetValue, java.util.List<java.lang.String> fields, CallerController caller)`
    `protected void` | `saveVariableStatuses()`
    `protected void` | `setChildrenConcurrencyEnabled(boolean childrenConcurrencyEnabled)`
    `protected void` | `setChildrenSortingEnabled(boolean childrenSortingEnabled)`
    `protected void` | `setChildrenViewPermissions(Permissions childrenViewPermissions)`
    `protected void` | `setContextManager(ContextManager contextManager)`
    `void` | `setDescription(java.lang.String description)`
    `protected void` | `setFireUpdateEvents(boolean fireUpdateEvents)`
    `void` | `setGroup(java.lang.String group)`
    `protected void` | `setIconId(java.lang.String iconId)`
    `void` | `setIndex(java.lang.Integer index)` Deprecated. Use ContextSortingHelper class for set tree context hierarchy
    `protected void` | `setName(java.lang.String name)`
    `void` | `setParent(C parent)`
    `protected void` | `setPermissionChecker(PermissionChecker permissionChecker)`
    `protected void` | `setPermissionCheckingEnabled(boolean permissionCheckingEnabled)`
    `protected void` | `setPermissions(Permissions permissions)`
    `void` | `setStatus(int status, java.lang.String comment)`
    `void` | `setType(java.lang.String type)`
    `protected void` | `setup()`
    `void` | `setup(ContextManager contextManager)` This method is called after the context has been added to a context tree and it became aware of its full path.
    `void` | `setupChildren()`
    `protected void` | `setupEvents()`
    `protected void` | `setupFunctions()`
    `void` | `setupMyself()`
    `void` | `setupPermissions()`
    `protected void` | `setupVariables()`
    `protected void` | `setValueCheckingEnabled(boolean valueCheckingEnabled)`
    `void` | `setVariable(java.lang.String name, CallerController caller, DataTable value)` Sets context variable to specified `value`.
    `void` | `setVariable(java.lang.String name, CallerController caller, java.lang.Object... value)` Sets context variable to specified `value`.
    `void` | `setVariable(java.lang.String name, CallerController caller, RequestController request, DataTable value)` Sets context variable to specified `value`.
    `void` | `setVariable(java.lang.String name, DataTable value)` Sets context variable to specified `value`.
    `void` | `setVariable(java.lang.String name, java.lang.Object... value)` Sets context variable to specified `value`.
    `boolean` | `setVariableField(java.lang.String variable, java.lang.String field, int record, java.lang.Object value, CallerController cc, RequestController request)`
    `boolean` | `setVariableField(java.lang.String variable, java.lang.String field, java.lang.Object value, CallerController cc)` Gets variable, updates field value in the first record, and sets variable.
    `void` | `setVariableField(java.lang.String variable, java.lang.String field, java.lang.Object value, java.lang.String compareField, java.lang.Object compareValue, CallerController cc)` Gets variable, updates field value in the records for those value of compareField equals compareValue, and sets variable.
    `protected boolean` | `setVariableImpl(VariableDefinition def, CallerController caller, RequestController request, DataTable value)`
    `protected boolean` | `shouldSeeChild(CallerController caller, Context<C> cur)`
    `void` | `start()` This method is called when context tree is being started after its initialization.
    `void` | `stop()` This method is called when context tree is being stopped before its de-initialization.
    `void` | `teardown()` This method is called when the context is being removed from context tree..
    `java.lang.String` | `toDetailedString()` Returns context detailed description that includes description and path.
    `java.lang.String` | `toString()`
    `protected void` | `updateEvent(Event ev, EventDefinition ed, CallerController caller, FireEventRequestController request)`
    `java.util.List<EventDefinition>` | `updateEventDefinitions(java.util.Map<java.lang.String,EventDefinition> source, java.lang.String baseGroup, boolean skipRemoval, java.lang.Object owner)`
    `protected boolean` | `updateFunctionAndAction(FunctionDefinition fd, boolean processAction, java.lang.Object owner)`
    `java.util.List<FunctionDefinition>` | `updateFunctionDefinitions(java.util.Map<java.lang.String,Pair<FunctionDefinition,java.lang.Boolean>> source, java.lang.String baseGroup, boolean skipRemoval, java.lang.Object owner)`
    `void` | `updatePrepare()` Prepare context to update.
    `java.util.List<VariableDefinition>` | `updateVariableDefinitions(java.util.Map<java.lang.String,VariableDefinition> source, java.lang.String baseGroup, boolean skipRemoval, boolean removeValues, java.lang.Object owner)`
    `void` | `updateVariableStatus(java.lang.String variable, VariableStatus status, boolean persistent)`
    `protected void` | `validateVariableValueToSet(VariableDefinition variableDefinition, DataTable value)`
    `VariableDefinition` | `varDefFromDataRecord(DataRecord rec)`
    `DataRecord` | `varDefToDataRecord(VariableDefinition vd)`
    `protected DataRecord` | `varDefToDataRecord(VariableDefinition vd, CallerController caller)`
    `protected void` | `variableUpdated(VariableDefinition def, CallerController caller, RequestController request, DataTable value, DataTable valueOld)`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.tibbo.aggregate.common.context.Context

      `setVariableField`

- - ### Field Detail

    - #### EXECUTOR_THREADS_PERCENT_FOR_VISITORS

          public static final int EXECUTOR_THREADS_PERCENT_FOR_VISITORS

      See Also:
        Constant Field Values

    - #### V_INFO

          public static final java.lang.String V_INFO

      See Also:
        Constant Field Values

    - #### V_CHILDREN

          public static final java.lang.String V_CHILDREN

      See Also:
        Constant Field Values

    - #### V_VARIABLES

          public static final java.lang.String V_VARIABLES

      See Also:
        Constant Field Values

    - #### V_FUNCTIONS

          public static final java.lang.String V_FUNCTIONS

      See Also:
        Constant Field Values

    - #### V_EVENTS

          public static final java.lang.String V_EVENTS

      See Also:
        Constant Field Values

    - #### V_ACTIONS

          public static final java.lang.String V_ACTIONS

      See Also:
        Constant Field Values

    - #### V_VARIABLE_STATUSES

          public static final java.lang.String V_VARIABLE_STATUSES

      See Also:
        Constant Field Values

    - #### F_GET_COPY_DATA

          public static final java.lang.String F_GET_COPY_DATA

      See Also:
        Constant Field Values

    - #### F_COPY

          public static final java.lang.String F_COPY

      See Also:
        Constant Field Values

    - #### F_COPY_TO_CHILDREN

          public static final java.lang.String F_COPY_TO_CHILDREN

      See Also:
        Constant Field Values

    - #### F_UPDATE_VARIABLE

          public static final java.lang.String F_UPDATE_VARIABLE

      See Also:
        Constant Field Values

    - #### F_GET_VARIABLE_STATUS

          public static final java.lang.String F_GET_VARIABLE_STATUS

      See Also:
        Constant Field Values

    - #### F_LOCKED_BY

          public static final java.lang.String F_LOCKED_BY

      See Also:
        Constant Field Values

    - #### F_LOCK

          public static final java.lang.String F_LOCK

      See Also:
        Constant Field Values

    - #### F_UNLOCK

          public static final java.lang.String F_UNLOCK

      See Also:
        Constant Field Values

    - #### F_BREAK_LOCK

          public static final java.lang.String F_BREAK_LOCK

      See Also:
        Constant Field Values

    - #### F_GET_ALIASES

          public static final java.lang.String F_GET_ALIASES

      See Also:
        Constant Field Values

    - #### F_FIRE_CONTEXT_EVENT

          public static final java.lang.String F_FIRE_CONTEXT_EVENT

      See Also:
        Constant Field Values

    - #### E_INFO

          public static final java.lang.String E_INFO

      See Also:
        Constant Field Values

    - #### E_UPDATED

          public static final java.lang.String E_UPDATED

      See Also:
        Constant Field Values

    - #### E_CHANGE

          public static final java.lang.String E_CHANGE

      See Also:
        Constant Field Values

    - #### E_DESTROYED

          public static final java.lang.String E_DESTROYED

      See Also:
        Constant Field Values

    - #### E_INFO_CHANGED

          public static final java.lang.String E_INFO_CHANGED

      See Also:
        Constant Field Values

    - #### E_VARIABLE_ADDED

          public static final java.lang.String E_VARIABLE_ADDED

      See Also:
        Constant Field Values

    - #### E_VARIABLE_REMOVED

          public static final java.lang.String E_VARIABLE_REMOVED

      See Also:
        Constant Field Values

    - #### E_FUNCTION_ADDED

          public static final java.lang.String E_FUNCTION_ADDED

      See Also:
        Constant Field Values

    - #### E_FUNCTION_REMOVED

          public static final java.lang.String E_FUNCTION_REMOVED

      See Also:
        Constant Field Values

    - #### E_EVENT_ADDED

          public static final java.lang.String E_EVENT_ADDED

      See Also:
        Constant Field Values

    - #### E_EVENT_REMOVED

          public static final java.lang.String E_EVENT_REMOVED

      See Also:
        Constant Field Values

    - #### E_ACTION_ADDED

          public static final java.lang.String E_ACTION_ADDED

      See Also:
        Constant Field Values

    - #### E_ACTION_REMOVED

          public static final java.lang.String E_ACTION_REMOVED

      See Also:
        Constant Field Values

    - #### E_ACTION_STATE_CHANGED

          public static final java.lang.String E_ACTION_STATE_CHANGED

      See Also:
        Constant Field Values

    - #### E_CHILD_REMOVED

          public static final java.lang.String E_CHILD_REMOVED

      See Also:
        Constant Field Values

    - #### E_CHILD_ADDED

          public static final java.lang.String E_CHILD_ADDED

      See Also:
        Constant Field Values

    - #### E_VARIABLE_STATUS_CHANGED

          public static final java.lang.String E_VARIABLE_STATUS_CHANGED

      See Also:
        Constant Field Values

    - #### VF_INFO_DESCRIPTION

          public static final java.lang.String VF_INFO_DESCRIPTION

      See Also:
        Constant Field Values

    - #### VF_INFO_TYPE

          public static final java.lang.String VF_INFO_TYPE

      See Also:
        Constant Field Values

    - #### VF_INFO_GROUP

          public static final java.lang.String VF_INFO_GROUP

      See Also:
        Constant Field Values

    - #### VF_INFO_ICON

          public static final java.lang.String VF_INFO_ICON

      See Also:
        Constant Field Values

    - #### VF_INFO_LOCAL_ROOT

          public static final java.lang.String VF_INFO_LOCAL_ROOT

      See Also:
        Constant Field Values

    - #### VF_INFO_PEER_ROOT

          public static final java.lang.String VF_INFO_PEER_ROOT

      See Also:
        Constant Field Values

    - #### VF_INFO_PEER_PRIMARY_ROOT

          public static final java.lang.String VF_INFO_PEER_PRIMARY_ROOT

      See Also:
        Constant Field Values

    - #### VF_INFO_REMOTE_ROOT

          public static final java.lang.String VF_INFO_REMOTE_ROOT

      See Also:
        Constant Field Values

    - #### VF_INFO_REMOTE_PATH

          public static final java.lang.String VF_INFO_REMOTE_PATH

      See Also:
        Constant Field Values

    - #### VF_INFO_MAPPED

          public static final java.lang.String VF_INFO_MAPPED

      See Also:
        Constant Field Values

    - #### VF_CHILDREN_NAME

          public static final java.lang.String VF_CHILDREN_NAME

      See Also:
        Constant Field Values

    - #### VF_CHILDREN_IS_CONTAINER

          public static final java.lang.String VF_CHILDREN_IS_CONTAINER

      See Also:
        Constant Field Values

    - #### VF_VARIABLE_STATUSES_COMMENT

          public static final java.lang.String VF_VARIABLE_STATUSES_COMMENT

      See Also:
        Constant Field Values

    - #### VF_VARIABLE_STATUSES_STATUS

          public static final java.lang.String VF_VARIABLE_STATUSES_STATUS

      See Also:
        Constant Field Values

    - #### VF_VARIABLE_STATUSES_NAME

          public static final java.lang.String VF_VARIABLE_STATUSES_NAME

      See Also:
        Constant Field Values

    - #### FIF_COPY_DATA_RECIPIENTS

          public static final java.lang.String FIF_COPY_DATA_RECIPIENTS

      See Also:
        Constant Field Values

    - #### FIF_COPY_DATA_GROUP

          public static final java.lang.String FIF_COPY_DATA_GROUP

      See Also:
        Constant Field Values

    - #### FOF_COPY_DATA_NAME

          public static final java.lang.String FOF_COPY_DATA_NAME

      See Also:
        Constant Field Values

    - #### FOF_COPY_DATA_DESCRIPTION

          public static final java.lang.String FOF_COPY_DATA_DESCRIPTION

      See Also:
        Constant Field Values

    - #### FOF_COPY_DATA_REPLICATE

          public static final java.lang.String FOF_COPY_DATA_REPLICATE

      See Also:
        Constant Field Values

    - #### FOF_COPY_DATA_FIELDS

          public static final java.lang.String FOF_COPY_DATA_FIELDS

      See Also:
        Constant Field Values

    - #### FOF_COPY_DATA_VALUE

          public static final java.lang.String FOF_COPY_DATA_VALUE

      See Also:
        Constant Field Values

    - #### FIF_REPLICATE_FIELDS_NAME

          public static final java.lang.String FIF_REPLICATE_FIELDS_NAME

      See Also:
        Constant Field Values

    - #### FIF_REPLICATE_FIELDS_DESCRIPTION

          public static final java.lang.String FIF_REPLICATE_FIELDS_DESCRIPTION

      See Also:
        Constant Field Values

    - #### FIF_REPLICATE_FIELDS_REPLICATE

          public static final java.lang.String FIF_REPLICATE_FIELDS_REPLICATE

      See Also:
        Constant Field Values

    - #### FIF_COPY_DATA_RECIPIENTS_RECIPIENT

          public static final java.lang.String FIF_COPY_DATA_RECIPIENTS_RECIPIENT

      See Also:
        Constant Field Values

    - #### FIF_LOCK_PROPERTIES_EDITOR_UUID

          public static final java.lang.String FIF_LOCK_PROPERTIES_EDITOR_UUID

      See Also:
        Constant Field Values

    - #### FIF_UNLOCK_PROPERTIES_EDITOR_UUID

          public static final java.lang.String FIF_UNLOCK_PROPERTIES_EDITOR_UUID

      See Also:
        Constant Field Values

    - #### FIF_VISIBLE_CHILDREN_FILTER_EXPRESSION

          public static final java.lang.String FIF_VISIBLE_CHILDREN_FILTER_EXPRESSION

      See Also:
        Constant Field Values

    - #### FIF_VISIBLE_CHILDREN_CONTEXT_MASK

          public static final java.lang.String FIF_VISIBLE_CHILDREN_CONTEXT_MASK

      See Also:
        Constant Field Values

    - #### FIF_VISIBLE_CHILDREN_PROPERTY_FILTERS

          public static final java.lang.String FIF_VISIBLE_CHILDREN_PROPERTY_FILTERS

      See Also:
        Constant Field Values

    - #### FIF_VISIBLE_CHILDREN_GLOBAL_FILTER

          public static final java.lang.String FIF_VISIBLE_CHILDREN_GLOBAL_FILTER

      See Also:
        Constant Field Values

    - #### FIF_VISIBLE_CHILDREN_OFFSET

          public static final java.lang.String FIF_VISIBLE_CHILDREN_OFFSET

      See Also:
        Constant Field Values

    - #### FIF_VISIBLE_CHILDREN_COUNT

          public static final java.lang.String FIF_VISIBLE_CHILDREN_COUNT

      See Also:
        Constant Field Values

    - #### FIF_VISIBLE_CHILDREN_SMART_FILTER_EXPRESSION

          public static final java.lang.String FIF_VISIBLE_CHILDREN_SMART_FILTER_EXPRESSION

      See Also:
        Constant Field Values

    - #### FIF_FIRE_EVENT_LEVEL

          public static final java.lang.String FIF_FIRE_EVENT_LEVEL

      See Also:
        Constant Field Values

    - #### FIF_FIRE_EVENT_EVENT

          public static final java.lang.String FIF_FIRE_EVENT_EVENT

      See Also:
        Constant Field Values

    - #### FIF_FIRE_EVENT_DATA

          public static final java.lang.String FIF_FIRE_EVENT_DATA

      See Also:
        Constant Field Values

    - #### FOF_FIRE_EVENT_ID

          public static final java.lang.String FOF_FIRE_EVENT_ID

      See Also:
        Constant Field Values

    - #### VF_VISIBLE_CHILDREN_PROPERTY_FILTERS_PROPERTY_NAME

          public static final java.lang.String VF_VISIBLE_CHILDREN_PROPERTY_FILTERS_PROPERTY_NAME

      See Also:
        Constant Field Values

    - #### VF_VISIBLE_CHILDREN_PROPERTY_FILTERS_PROPERTY_VALUE

          public static final java.lang.String VF_VISIBLE_CHILDREN_PROPERTY_FILTERS_PROPERTY_VALUE

      See Also:
        Constant Field Values

    - #### FOF_LOCKED_BY_OWNER_NAME

          public static final java.lang.String FOF_LOCKED_BY_OWNER_NAME

      See Also:
        Constant Field Values

    - #### FOF_LOCK_OWNER_NAME

          public static final java.lang.String FOF_LOCK_OWNER_NAME

      See Also:
        Constant Field Values

    - #### FOF_UNLOCK_UNLOCKED

          public static final java.lang.String FOF_UNLOCK_UNLOCKED

      See Also:
        Constant Field Values

    - #### FOF_VISIBLE_CHILDREN_BATCH

          public static final java.lang.String FOF_VISIBLE_CHILDREN_BATCH

      See Also:
        Constant Field Values

    - #### FOF_VISIBLE_CHILDREN_TOTAL_COUNT

          public static final java.lang.String FOF_VISIBLE_CHILDREN_TOTAL_COUNT

      See Also:
        Constant Field Values

    - #### FOF_GET_ALIASES_ENTITY_TYPE

          public static final java.lang.String FOF_GET_ALIASES_ENTITY_TYPE

      See Also:
        Constant Field Values

    - #### FOF_GET_ALIASES_ALIAS_NAME

          public static final java.lang.String FOF_GET_ALIASES_ALIAS_NAME

      See Also:
        Constant Field Values

    - #### FOF_GET_ALIASES_NAME

          public static final java.lang.String FOF_GET_ALIASES_NAME

      See Also:
        Constant Field Values

    - #### EF_INFO_INFO

          public static final java.lang.String EF_INFO_INFO

      See Also:
        Constant Field Values

    - #### EF_EVENT_REMOVED_NAME

          public static final java.lang.String EF_EVENT_REMOVED_NAME

      See Also:
        Constant Field Values

    - #### EF_FUNCTION_REMOVED_NAME

          public static final java.lang.String EF_FUNCTION_REMOVED_NAME

      See Also:
        Constant Field Values

    - #### EF_VARIABLE_REMOVED_NAME

          public static final java.lang.String EF_VARIABLE_REMOVED_NAME

      See Also:
        Constant Field Values

    - #### EF_ACTION_REMOVED_NAME

          public static final java.lang.String EF_ACTION_REMOVED_NAME

      See Also:
        Constant Field Values

    - #### EF_CHILD_REMOVED_CHILD

          public static final java.lang.String EF_CHILD_REMOVED_CHILD

      See Also:
        Constant Field Values

    - #### EF_CHILD_ADDED_CHILD

          public static final java.lang.String EF_CHILD_ADDED_CHILD

      See Also:
        Constant Field Values

    - #### FIELD_REPLICATE_VARIABLE

          public static final java.lang.String FIELD_REPLICATE_VARIABLE

      See Also:
        Constant Field Values

    - #### FIELD_REPLICATE_SUCCESSFUL

          public static final java.lang.String FIELD_REPLICATE_SUCCESSFUL

      See Also:
        Constant Field Values

    - #### FIELD_REPLICATE_ERRORS

          public static final java.lang.String FIELD_REPLICATE_ERRORS

      See Also:
        Constant Field Values

    - #### V_UPDATE_VARIABLE

          public static final java.lang.String V_UPDATE_VARIABLE

      See Also:
        Constant Field Values

    - #### V_UPDATE_VARIABLE_EXPRESSION

          public static final java.lang.String V_UPDATE_VARIABLE_EXPRESSION

      See Also:
        Constant Field Values

    - #### V_VARIABLE_NAME

          public static final java.lang.String V_VARIABLE_NAME

      See Also:
        Constant Field Values

    - #### EF_UPDATED_VARIABLE

          public static final java.lang.String EF_UPDATED_VARIABLE

      See Also:
        Constant Field Values

    - #### EF_UPDATED_VALUE

          public static final java.lang.String EF_UPDATED_VALUE

      See Also:
        Constant Field Values

    - #### EF_UPDATED_VALUE_OLD

          public static final java.lang.String EF_UPDATED_VALUE_OLD

      See Also:
        Constant Field Values

    - #### EF_UPDATED_USER

          public static final java.lang.String EF_UPDATED_USER

      See Also:
        Constant Field Values

    - #### EF_UPDATED_VARIABLE_STATUS

          public static final java.lang.String EF_UPDATED_VARIABLE_STATUS

      See Also:
        Constant Field Values

    - #### EF_UPDATED_UPDATE_ORIGINATOR

          public static final java.lang.String EF_UPDATED_UPDATE_ORIGINATOR

      See Also:
        Constant Field Values

    - #### EF_CHANGE_VARIABLE

          public static final java.lang.String EF_CHANGE_VARIABLE

      See Also:
        Constant Field Values

    - #### EF_CHANGE_VALUE

          public static final java.lang.String EF_CHANGE_VALUE

      See Also:
        Constant Field Values

    - #### EF_CHANGE_DATA

          public static final java.lang.String EF_CHANGE_DATA

      See Also:
        Constant Field Values

    - #### EF_CHANGE_FORMAT

          public static final java.lang.String EF_CHANGE_FORMAT

      See Also:
        Constant Field Values

    - #### FIELD_VD_NAME

          public static final java.lang.String FIELD_VD_NAME

      See Also:
        Constant Field Values

    - #### FIELD_VD_FORMAT

          public static final java.lang.String FIELD_VD_FORMAT

      See Also:
        Constant Field Values

    - #### FIELD_VD_DESCRIPTION

          public static final java.lang.String FIELD_VD_DESCRIPTION

      See Also:
        Constant Field Values

    - #### FIELD_VD_READABLE

          public static final java.lang.String FIELD_VD_READABLE

      See Also:
        Constant Field Values

    - #### FIELD_VD_WRITABLE

          public static final java.lang.String FIELD_VD_WRITABLE

      See Also:
        Constant Field Values

    - #### FIELD_VD_HELP

          public static final java.lang.String FIELD_VD_HELP

      See Also:
        Constant Field Values

    - #### FIELD_VD_GROUP

          public static final java.lang.String FIELD_VD_GROUP

      See Also:
        Constant Field Values

    - #### FIELD_VD_ICON_ID

          public static final java.lang.String FIELD_VD_ICON_ID

      See Also:
        Constant Field Values

    - #### FIELD_VD_HELP_ID

          public static final java.lang.String FIELD_VD_HELP_ID

      See Also:
        Constant Field Values

    - #### FIELD_VD_CACHE_TIME

          public static final java.lang.String FIELD_VD_CACHE_TIME

      See Also:
        Constant Field Values

    - #### FIELD_VD_SERVER_CACHING_MODE

          public static final java.lang.String FIELD_VD_SERVER_CACHING_MODE

      See Also:
        Constant Field Values

    - #### FIELD_VD_ADD_PREVIOUS_VALUE_TO_VARIABLE_UPDATE_EVENT

          public static final java.lang.String FIELD_VD_ADD_PREVIOUS_VALUE_TO_VARIABLE_UPDATE_EVENT

      See Also:
        Constant Field Values

    - #### FIELD_FD_NAME

          public static final java.lang.String FIELD_FD_NAME

      See Also:
        Constant Field Values

    - #### FIELD_FD_INPUTFORMAT

          public static final java.lang.String FIELD_FD_INPUTFORMAT

      See Also:
        Constant Field Values

    - #### FIELD_FD_OUTPUTFORMAT

          public static final java.lang.String FIELD_FD_OUTPUTFORMAT

      See Also:
        Constant Field Values

    - #### FIELD_FD_DESCRIPTION

          public static final java.lang.String FIELD_FD_DESCRIPTION

      See Also:
        Constant Field Values

    - #### FIELD_FD_HELP

          public static final java.lang.String FIELD_FD_HELP

      See Also:
        Constant Field Values

    - #### FIELD_FD_GROUP

          public static final java.lang.String FIELD_FD_GROUP

      See Also:
        Constant Field Values

    - #### FIELD_FD_ICON_ID

          public static final java.lang.String FIELD_FD_ICON_ID

      See Also:
        Constant Field Values

    - #### FIELD_FD_CONCURRENT

          public static final java.lang.String FIELD_FD_CONCURRENT

      See Also:
        Constant Field Values

    - #### FIELD_FD_PERMISSIONS

          public static final java.lang.String FIELD_FD_PERMISSIONS

      See Also:
        Constant Field Values

    - #### FIELD_ED_NAME

          public static final java.lang.String FIELD_ED_NAME

      See Also:
        Constant Field Values

    - #### FIELD_ED_FORMAT

          public static final java.lang.String FIELD_ED_FORMAT

      See Also:
        Constant Field Values

    - #### FIELD_ED_DESCRIPTION

          public static final java.lang.String FIELD_ED_DESCRIPTION

      See Also:
        Constant Field Values

    - #### FIELD_ED_HELP

          public static final java.lang.String FIELD_ED_HELP

      See Also:
        Constant Field Values

    - #### FIELD_ED_LEVEL

          public static final java.lang.String FIELD_ED_LEVEL

      See Also:
        Constant Field Values

    - #### FIELD_ED_GROUP

          public static final java.lang.String FIELD_ED_GROUP

      See Also:
        Constant Field Values

    - #### FIELD_ED_ICON_ID

          public static final java.lang.String FIELD_ED_ICON_ID

      See Also:
        Constant Field Values

    - #### DEFAULT_EVENT_LEVEL

          public static final int DEFAULT_EVENT_LEVEL

      See Also:
        Constant Field Values

    - #### VARIABLE_DEFINITION_FORMAT

          public static final TableFormat VARIABLE_DEFINITION_FORMAT

    - #### VFT_VISIBLE_CHILDREN

          public static final TableFormat VFT_VISIBLE_CHILDREN

    - #### FUNCTION_DEFINITION_FORMAT

          public static final TableFormat FUNCTION_DEFINITION_FORMAT

    - #### EF_FUNCTION_ADDED

          public static final TableFormat EF_FUNCTION_ADDED

    - #### EVENT_DEFINITION_FORMAT

          public static final TableFormat EVENT_DEFINITION_FORMAT

    - #### EF_EVENT_ADDED

          public static final TableFormat EF_EVENT_ADDED

    - #### VFT_CHILDREN

          protected static final TableFormat VFT_CHILDREN

    - #### INFO_DEFINITION_FORMAT

          public static final TableFormat INFO_DEFINITION_FORMAT

    - #### ACTION_DEF_FORMAT

          public static final TableFormat ACTION_DEF_FORMAT

    - #### RESOURCE_MASKS_FORMAT

          public static final TableFormat RESOURCE_MASKS_FORMAT

    - #### FIFT_GET_COPY_DATA

          public static final TableFormat FIFT_GET_COPY_DATA

    - #### FIFT_GET_COPY_DATA_RECIPIENTS

          public static final TableFormat FIFT_GET_COPY_DATA_RECIPIENTS

    - #### REPLICATE_INPUT_FORMAT

          public static final TableFormat REPLICATE_INPUT_FORMAT

    - #### FIFT_REPLICATE_FIELDS

          public static final TableFormat FIFT_REPLICATE_FIELDS

    - #### REPLICATE_OUTPUT_FORMAT

          public static final TableFormat REPLICATE_OUTPUT_FORMAT

    - #### REPLICATE_TO_CHILDREN_OUTPUT_FORMAT

          protected static final TableFormat REPLICATE_TO_CHILDREN_OUTPUT_FORMAT

    - #### FIFT_UPDATE_VARIABLE

          public static final TableFormat FIFT_UPDATE_VARIABLE

    - #### FIFT_GET_VARIABLE_STATUS

          public static final TableFormat FIFT_GET_VARIABLE_STATUS

    - #### FIFT_LOCK

          public static final TableFormat FIFT_LOCK

    - #### FIFT_UNLOCK

          public static final TableFormat FIFT_UNLOCK

    - #### FIFT_VISIBLE_CHILDREN

          public static final TableFormat FIFT_VISIBLE_CHILDREN

    - #### FOFT_LOCKED_BY

          public static final TableFormat FOFT_LOCKED_BY

    - #### FOFT_LOCK

          public static final TableFormat FOFT_LOCK

    - #### FOFT_UNLOCK

          public static final TableFormat FOFT_UNLOCK

    - #### FOFT_VISIBLE_CHILDREN

          public static final TableFormat FOFT_VISIBLE_CHILDREN

    - #### FOFT_GET_ALIASES

          public static final TableFormat FOFT_GET_ALIASES

    - #### FIFT_FIRE_CONTEXT_EVENT

          public static final TableFormat FIFT_FIRE_CONTEXT_EVENT

    - #### FOFT_FIRE_CONTEXT_EVENT

          public static final TableFormat FOFT_FIRE_CONTEXT_EVENT

    - #### EF_UPDATED

          public static final TableFormat EF_UPDATED

    - #### EF_CHANGE

          public static final TableFormat EF_CHANGE

    - #### EFT_INFO

          public static final TableFormat EFT_INFO

    - #### EFT_VARIABLE_REMOVED

          public static final TableFormat EFT_VARIABLE_REMOVED

    - #### EFT_EVENT_REMOVED

          public static final TableFormat EFT_EVENT_REMOVED

    - #### EFT_FUNCTION_REMOVED

          public static final TableFormat EFT_FUNCTION_REMOVED

    - #### EFT_CHILD_REMOVED

          public static final TableFormat EFT_CHILD_REMOVED

    - #### EFT_CHILD_ADDED

          public static final TableFormat EFT_CHILD_ADDED

    - #### EFT_ACTION_REMOVED

          public static final TableFormat EFT_ACTION_REMOVED

    - #### VD_INFO

          public static final VariableDefinition VD_INFO

    - #### VD_VARIABLES

          public static final VariableDefinition VD_VARIABLES

    - #### VD_FUNCTIONS

          public static final VariableDefinition VD_FUNCTIONS

    - #### VD_EVENTS

          public static final VariableDefinition VD_EVENTS

    - #### VD_ACTIONS

          public static final VariableDefinition VD_ACTIONS

    - #### VD_CHILDREN

          public static final VariableDefinition VD_CHILDREN

    - #### FD_GET_COPY_DATA

          protected static final FunctionDefinition FD_GET_COPY_DATA

    - #### FD_COPY

          protected static final FunctionDefinition FD_COPY

    - #### FD_COPY_TO_CHILDREN

          protected static final FunctionDefinition FD_COPY_TO_CHILDREN

    - #### FD_UPDATE_VARIABLE

          protected static final FunctionDefinition FD_UPDATE_VARIABLE

    - #### FD_GET_ALIASES

          protected static final FunctionDefinition FD_GET_ALIASES

    - #### FD_FIRE_CONTEXT_EVENT

          protected static final FunctionDefinition FD_FIRE_CONTEXT_EVENT

    - #### ED_INFO

          public static final EventDefinition ED_INFO

    - #### ED_CHILD_ADDED

          public static final EventDefinition ED_CHILD_ADDED

    - #### ED_CHILD_REMOVED

          public static final EventDefinition ED_CHILD_REMOVED

    - #### ED_VARIABLE_ADDED

          public static final EventDefinition ED_VARIABLE_ADDED

    - #### ED_VARIABLE_REMOVED

          public static final EventDefinition ED_VARIABLE_REMOVED

    - #### ED_FUNCTION_ADDED

          public static final EventDefinition ED_FUNCTION_ADDED

    - #### ED_FUNCTION_REMOVED

          public static final EventDefinition ED_FUNCTION_REMOVED

    - #### ED_EVENT_ADDED

          public static final EventDefinition ED_EVENT_ADDED

    - #### ED_EVENT_REMOVED

          public static final EventDefinition ED_EVENT_REMOVED

    - #### ED_ACTION_ADDED

          public static final EventDefinition ED_ACTION_ADDED

    - #### ED_ACTION_REMOVED

          public static final EventDefinition ED_ACTION_REMOVED

    - #### ED_ACTION_STATE_CHANGED

          public static final EventDefinition ED_ACTION_STATE_CHANGED

    - #### ED_INFO_CHANGED

          public static final EventDefinition ED_INFO_CHANGED

    - #### ED_UPDATED

          public static final EventDefinition ED_UPDATED

    - #### ED_CHANGE

          public static final EventDefinition ED_CHANGE

    - #### ED_DESTROYED

          public static final EventDefinition ED_DESTROYED

    - #### CALLER_CONTROLLER_PROPERTY_DEBUG

          public static final java.lang.String CALLER_CONTROLLER_PROPERTY_DEBUG

      See Also:
        Constant Field Values

    - #### CALLER_CONTROLLER_PROPERTY_NO_UPDATED_EVENTS

          public static final java.lang.String CALLER_CONTROLLER_PROPERTY_NO_UPDATED_EVENTS

      See Also:
        Constant Field Values

    - #### CALLER_CONTROLLER_PROPERTY_NO_CHANGE_EVENTS

          public static final java.lang.String CALLER_CONTROLLER_PROPERTY_NO_CHANGE_EVENTS

      See Also:
        Constant Field Values

    - #### CALLER_CONTROLLER_PROPERTY_NO_STATISTICS

          public static final java.lang.String CALLER_CONTROLLER_PROPERTY_NO_STATISTICS

      See Also:
        Constant Field Values

    - #### CALLER_CONTROLLER_PROPERTY_NO_VALIDATION

          public static final java.lang.String CALLER_CONTROLLER_PROPERTY_NO_VALIDATION

      See Also:
        Constant Field Values

    - #### INDEX_HIGHEST

          public static final int INDEX_HIGHEST

      See Also:
        Constant Field Values

    - #### INDEX_VERY_HIGH

          public static final int INDEX_VERY_HIGH

      See Also:
        Constant Field Values

    - #### INDEX_HIGH

          public static final int INDEX_HIGH

      See Also:
        Constant Field Values

    - #### INDEX_HIGHER

          public static final int INDEX_HIGHER

      See Also:
        Constant Field Values

    - #### INDEX_NORMAL

          public static final int INDEX_NORMAL

      See Also:
        Constant Field Values

    - #### INDEX_LOWER

          public static final int INDEX_LOWER

      See Also:
        Constant Field Values

    - #### INDEX_LOW

          public static final int INDEX_LOW

      See Also:
        Constant Field Values

    - #### INDEX_VERY_LOW

          public static final int INDEX_VERY_LOW

      See Also:
        Constant Field Values

    - #### INDEX_LOWEST

          public static final int INDEX_LOWEST

      See Also:
        Constant Field Values

    - #### SORT_THRESHOLD

          protected static final int SORT_THRESHOLD

      See Also:
        Constant Field Values

    - #### currentSource

          protected static final java.lang.ThreadLocal<Pinpoint> currentSource

    - #### ready

          protected final java.util.concurrent.CompletableFuture<C extends Context> ready

  - ### Constructor Detail

    - #### AbstractContext

          public AbstractContext(java.lang.String name)

  - ### Method Detail

    - #### setup

          public final void setup(ContextManager contextManager)

      Description copied from interface: `Context`
      This method is called after the context has been added to a context tree and it became aware of its full path. Note, that default implementation of this method in AbstractContext calls tree methods: setupPermissions(), setupMyself() and setupChildren(). These methods should provide initialization logic in inherited classes instead of overridden setup() method.
      Specified by:
        `setup` in interface `Context<C extends Context>`
      Parameters:
        `contextManager` - ContextManager heading current context tree

    - #### setup

          protected final void setup()

    - #### setupPermissions

          public void setupPermissions()

    - #### setupMyself

          public void setupMyself()
                           throws ContextException

      Throws:
        `ContextException`

    - #### setupChildren

          public void setupChildren()
                             throws ContextException

      Throws:
        `ContextException`

    - #### teardown

          public void teardown()

      Description copied from interface: `Context`
      This method is called when the context is being removed from context tree..
      Specified by:
        `teardown` in interface `Context<C extends Context>`

    - #### start

          public void start()

      Description copied from interface: `Context`
      This method is called when context tree is being started after its initialization. All contexts in the tree should be available at the moment of call.
      Specified by:
        `start` in interface `Context<C extends Context>`

    - #### stop

          public void stop()

      Description copied from interface: `Context`
      This method is called when context tree is being stopped before its de-initialization. All contexts in the tree should be available at the moment of call.
      Specified by:
        `stop` in interface `Context<C extends Context>`

    - #### compareTo

          public int compareTo(Context context)

      Specified by:
        `compareTo` in interface `java.lang.Comparable<C extends Context>`

    - #### getChildren

          public java.util.List<C> getChildren(CallerController caller)

      Description copied from interface: `Context`
      Returns list of children contexts that are accessible by the specified `CallerController`.
      Specified by:
        `getChildren` in interface `Context<C extends Context>`

    - #### shouldSeeChild

          protected boolean shouldSeeChild(CallerController caller,
                                           Context<C> cur)

    - #### getChildren

          public java.util.List<C> getChildren()

      Description copied from interface: `Context`
      Returns list of children contexts.
      Specified by:
        `getChildren` in interface `Context<C extends Context>`

    - #### getVisibleChildren

          public java.util.List<C> getVisibleChildren(CallerController caller)

      Description copied from interface: `Context`
      Returns list of visible children contexts.
      Specified by:
        `getVisibleChildren` in interface `Context<C extends Context>`

    - #### hasVisibleChild

          public boolean hasVisibleChild(java.lang.String name,
                                         CallerController caller)

      Description copied from interface: `Context`
      Check if the visible child of the context is available.
      Specified by:
        `hasVisibleChild` in interface `Context<C extends Context>`

    - #### getVisibleChildren

          public java.util.List<C> getVisibleChildren()

      Description copied from interface: `Context`
      Returns list of visible children contexts.
      Specified by:
        `getVisibleChildren` in interface `Context<C extends Context>`

    - #### isMapped

          public boolean isMapped()

      Description copied from interface: `Context`
      Returns true if context's visible children are mapped (e.g. for group and aggregation contexts).
      Specified by:
        `isMapped` in interface `Context<C extends Context>`

    - #### getMappedChildren

          public java.util.List<C> getMappedChildren(CallerController caller)

      Description copied from interface: `Context`
      Returns list of mapped children contexts.
      Specified by:
        `getMappedChildren` in interface `Context<C extends Context>`

    - #### getMappedChildren

          public java.util.List<C> getMappedChildren()

      Description copied from interface: `Context`
      Returns list of mapped children contexts.
      Specified by:
        `getMappedChildren` in interface `Context<C extends Context>`

    - #### hasMappedChild

          public boolean hasMappedChild(java.lang.String contextName,
                                        CallerController callerController)

      Description copied from interface: `Context`
      Check if the mapped child of this context is available.
      Specified by:
        `hasMappedChild` in interface `Context<C extends Context>`

    - #### getName

          public java.lang.String getName()

      Description copied from interface: `Context`
      Returns context name.
      Specified by:
        `getName` in interface `Context<C extends Context>`

    - #### getDescription

          public java.lang.String getDescription()

      Description copied from interface: `Context`
      Returns context description.
      Specified by:
        `getDescription` in interface `Context<C extends Context>`

    - #### setDescription

          public void setDescription(java.lang.String description)

    - #### getParent

          public C getParent()

      Description copied from interface: `Context`
      Returns parent of this context.
      Specified by:
        `getParent` in interface `Context<C extends Context>`

    - #### hasParent

          public boolean hasParent(C parentContext)

      Description copied from interface: `Context`
      Returns true if parentContext is a parent of this context or some of its parents.
      Specified by:
        `hasParent` in interface `Context<C extends Context>`

    - #### getRoot

          public C getRoot()

      Description copied from interface: `Context`
      Returns root context of the context tree containing this context.
      Specified by:
        `getRoot` in interface `Context<C extends Context>`

    - #### get

          public C get(java.lang.String contextPath,
                       CallerController caller)

      Description copied from interface: `Context`
      Returns context with the selected path. `path` argument may be absolute of relative to this context. This method uses provided `CallerController` for permission checking.
      Specified by:
        `get` in interface `Context<C extends Context>`

    - #### get

          public C get(java.lang.String contextName)

      Description copied from interface: `Context`
      Returns context with the selected path. `path` argument may be absolute of relative to this context. Note: if this Context is a part of distributed context tree and path argument is not relative, the method will return local context matching its remote "peer" with given path. To get the local context with the given path, use `ContextManager.get(String)` instead.
      Specified by:
        `get` in interface `Context<C extends Context>`

    - #### getPermissions

          public Permissions getPermissions()

      Description copied from interface: `Context`
      Returns context permissions.
      Specified by:
        `getPermissions` in interface `Context<C extends Context>`

    - #### awaitInitialized

          public AbstractContext awaitInitialized()
                                           throws ContextException

      Throws:
        `ContextException`

    - #### setName

          protected void setName(java.lang.String name)

    - #### setParent

          public void setParent(C parent)

      Specified by:
        `setParent` in interface `Context<C extends Context>`

    - #### setPermissions

          protected void setPermissions(Permissions permissions)

    - #### setPermissionChecker

          protected void setPermissionChecker(PermissionChecker permissionChecker)

    - #### setFireUpdateEvents

          protected void setFireUpdateEvents(boolean fireUpdateEvents)

    - #### isFireUpdateEvents

          protected boolean isFireUpdateEvents()

    - #### setContextManager

          protected void setContextManager(ContextManager contextManager)

    - #### setChildrenViewPermissions

          protected void setChildrenViewPermissions(Permissions childrenViewPermissions)

    - #### setChildrenSortingEnabled

          protected void setChildrenSortingEnabled(boolean childrenSortingEnabled)

    - #### isChildrenSortingEnabled

          public boolean isChildrenSortingEnabled()

    - #### setValueCheckingEnabled

          protected void setValueCheckingEnabled(boolean valueCheckingEnabled)

    - #### isChildrenConcurrencyEnabled

          public boolean isChildrenConcurrencyEnabled()

    - #### setChildrenConcurrencyEnabled

          protected void setChildrenConcurrencyEnabled(boolean childrenConcurrencyEnabled)

    - #### checkPermissions

          protected void checkPermissions(Permissions needPermissions,
                                          CallerController caller,
                                          EntityDefinition accessedEntityDefinition)
                                   throws ContextSecurityException

      Throws:
        `ContextSecurityException`

    - #### checkPermissions

          public boolean checkPermissions(Permissions needPermissions,
                                          CallerController caller,
                                          Context accessedContext,
                                          EntityDefinition accessedEntityDefinition)

    - #### addChild

          public void addChild(C child)

      Description copied from interface: `Context`
      Adds new child to the current context.
      Specified by:
        `addChild` in interface `Context<C extends Context>`

    - #### addChild

          public void addChild(C child,
                               java.lang.Integer index)

    - #### addChild

          public void addChild(C child,
                               DataTable childInfo)

    - #### addChild

          public void addChild(C child,
                               java.lang.Integer index,
                               DataTable childInfo)

    - #### removeFromParent

          public void removeFromParent()

    - #### destroy

          public void destroy(boolean moving)

      Description copied from interface: `Context`
      Permanently destroys this context.
      Specified by:
        `destroy` in interface `Context<C extends Context>`

    - #### destroyChildren

          protected void destroyChildren(boolean moving)

    - #### removeChild

          public void removeChild(C child)

      Description copied from interface: `Context`
      Removes child of current context.
      Specified by:
        `removeChild` in interface `Context<C extends Context>`

    - #### removeChild

          public void removeChild(java.lang.String name)

      Description copied from interface: `Context`
      Removes child with specified name.
      Specified by:
        `removeChild` in interface `Context<C extends Context>`

    - #### reorderChild

          protected void reorderChild(C child,
                                      int index)

    - #### destroyChild

          public void destroyChild(C child,
                                   boolean moving)

      Description copied from interface: `Context`
      Permanently destroys child of current context.
      Specified by:
        `destroyChild` in interface `Context<C extends Context>`

    - #### updatePrepare

          public void updatePrepare()

      Description copied from interface: `Context`
      Prepare context to update.
      Specified by:
        `updatePrepare` in interface `Context<C extends Context>`

    - #### movePrepare

          protected void movePrepare(java.lang.String oldPath,
                                     java.lang.String oldName,
                                     java.lang.String newPath,
                                     java.lang.String newName)
                              throws ContextException

      Throws:
        `ContextException`

    - #### moveInternal

          protected void moveInternal(java.lang.String oldPath,
                                      java.lang.String oldName,
                                      java.lang.String newPath,
                                      java.lang.String newName)
                               throws ContextException

      Throws:
        `ContextException`

    - #### moveFinalize

          protected void moveFinalize(java.lang.String oldPath,
                                      java.lang.String oldName,
                                      java.lang.String newPath,
                                      java.lang.String newName)
                               throws ContextException

      Throws:
        `ContextException`

    - #### move

          public void move(C newParent,
                           java.lang.String newName)
                    throws ContextException

      Description copied from interface: `Context`
      Moves and/or renames the context.
      Specified by:
        `move` in interface `Context<C extends Context>`
      Throws:
        `ContextException`

    - #### getChild

          public C getChild(java.lang.String name,
                            CallerController caller)

      Description copied from interface: `Context`
      Returns child of this context with the specified name. `path` argument may be absolute of relative to this context. Note: if this Context is a part of distributed context tree and path argument is not relative, the method will return local context matching its remote "peer" with given path. To get the local context with the given path, use `ContextManager.get(String, CallerController)` instead. This method uses provided `CallerController` for permission checking.
      Specified by:
        `getChild` in interface `Context<C extends Context>`

    - #### getChild

          public C getChild(java.lang.String name)

      Description copied from interface: `Context`
      Returns child of this context with the specified name.
      Specified by:
        `getChild` in interface `Context<C extends Context>`

    - #### getPath

          public java.lang.String getPath()

      Description copied from interface: `Context`
      Returns context path (full name).
      Specified by:
        `getPath` in interface `Context<C extends Context>`

    - #### addEventListener

          public boolean addEventListener(java.lang.String name,
                                          ContextEventListener listener)

      Description copied from interface: `Context`
      Adds listener of event with specified name.
      Specified by:
        `addEventListener` in interface `Context<C extends Context>`

    - #### addEventListener

          public boolean addEventListener(java.lang.String name,
                                          ContextEventListener listener,
                                          boolean weak)

      Description copied from interface: `Context`
      Adds listener of event with specified name. This method allows to add auto-cleaned listeners by setting weak flag to true.
      Specified by:
        `addEventListener` in interface `Context<C extends Context>`

    - #### removeEventListener

          public boolean removeEventListener(java.lang.String name,
                                             ContextEventListener listener)

      Description copied from interface: `Context`
      Removes listener of event with specified name.
      Specified by:
        `removeEventListener` in interface `Context<C extends Context>`

    - #### getVariableDefinitions

          public java.util.List<VariableDefinition> getVariableDefinitions(CallerController caller)

      Description copied from interface: `Context`
      Returns list of variables available for specified `CallerController`.
      Specified by:
        `getVariableDefinitions` in interface `Context<C extends Context>`

    - #### getVariableDefinitions

          public java.util.List<VariableDefinition> getVariableDefinitions(CallerController caller,
                                                                           boolean includeHidden)

      Description copied from interface: `Context`
      Returns list of variables.
      Specified by:
        `getVariableDefinitions` in interface `Context<C extends Context>`

    - #### getVariableDefinitions

          public java.util.List<VariableDefinition> getVariableDefinitions()

      Description copied from interface: `Context`
      Returns list of variables.
      Specified by:
        `getVariableDefinitions` in interface `Context<C extends Context>`

    - #### getVariableDefinitions

          public java.util.List<VariableDefinition> getVariableDefinitions(CallerController caller,
                                                                           java.lang.String group)

      Description copied from interface: `Context`
      Returns list of variables belonging to `group` that are available for specified `CallerController`.
      Specified by:
        `getVariableDefinitions` in interface `Context<C extends Context>`

    - #### getVariableDefinitions

          public java.util.List<VariableDefinition> getVariableDefinitions(java.lang.String group)

      Description copied from interface: `Context`
      Returns list of variables belonging to `group`.
      Specified by:
        `getVariableDefinitions` in interface `Context<C extends Context>`

    - #### getPermissionChecker

          public PermissionChecker getPermissionChecker()

    - #### getChildrenViewPermissions

          public Permissions getChildrenViewPermissions()

      Description copied from interface: `Context`
      Returns permissions required to access children of this context.
      Specified by:
        `getChildrenViewPermissions` in interface `Context<C extends Context>`

    - #### getContextManager

          public ContextManager<C> getContextManager()

      Description copied from interface: `Context`
      Returns context manager those context tree contains this context.
      Specified by:
        `getContextManager` in interface `Context<C extends Context>`

    - #### isSetupComplete

          public boolean isSetupComplete()

      Description copied from interface: `Context`
      This method should return true if the context has already been initialized and setupMyself() finished execution. Its default implementation in AbstractContext should not be overridden.
      Specified by:
        `isSetupComplete` in interface `Context<C extends Context>`
      Returns:
        true if setupMyself() has already been completed.

    - #### isStarted

          public boolean isStarted()

      Description copied from interface: `Context`
      Returns true if context was started but not yet stopped.
      Specified by:
        `isStarted` in interface `Context<C extends Context>`

    - #### isStopped

          public boolean isStopped()

    - #### isProtected

          public boolean isProtected()

    - #### isEntityProtected

          public boolean isEntityProtected(EntityDefinition ed)

    - #### isInitializedStatus

          public boolean isInitializedStatus()

      Description copied from interface: `Context`
      This method should return true if the context status has already been initialized.
      Specified by:
        `isInitializedStatus` in interface `Context<C extends Context>`
      Returns:
        true if basic context status has been initialized.

    - #### isInitializedInfo

          public boolean isInitializedInfo()

      Description copied from interface: `Context`
      This method should return true if the context has already been initialized its basic information (description, type, etc).
      Specified by:
        `isInitializedInfo` in interface `Context<C extends Context>`
      Returns:
        true if basic context information has been initialized.

    - #### isInitializedChildren

          public boolean isInitializedChildren()

      Description copied from interface: `Context`
      This method should return true if the context has already been initialized its children.
      Specified by:
        `isInitializedChildren` in interface `Context<C extends Context>`
      Returns:
        true if context children have been initialized.

    - #### isInitializedVariables

          public boolean isInitializedVariables()

      Description copied from interface: `Context`
      This method should return true if the context has already been initialized its variables.
      Specified by:
        `isInitializedVariables` in interface `Context<C extends Context>`
      Returns:
        true if context variables have been initialized.

    - #### isInitializedFunctions

          public boolean isInitializedFunctions()

      Description copied from interface: `Context`
      This method should return true if the context has already been initialized its functions.
      Specified by:
        `isInitializedFunctions` in interface `Context<C extends Context>`
      Returns:
        true if context functions have been initialized.

    - #### isInitializedEvents

          public boolean isInitializedEvents()

      Description copied from interface: `Context`
      This method should return true if the context has already been initialized its events.
      Specified by:
        `isInitializedEvents` in interface `Context<C extends Context>`
      Returns:
        true if context events have been initialized.

    - #### getFunctionDefinitions

          public java.util.List<FunctionDefinition> getFunctionDefinitions(CallerController caller)

      Description copied from interface: `Context`
      Returns list of functions available for specified `CallerController`.
      Specified by:
        `getFunctionDefinitions` in interface `Context<C extends Context>`

    - #### getFunctionDefinitions

          public java.util.List<FunctionDefinition> getFunctionDefinitions(CallerController caller,
                                                                           boolean includeHidden)

      Description copied from interface: `Context`
      Returns list of functions.
      Specified by:
        `getFunctionDefinitions` in interface `Context<C extends Context>`

    - #### getFunctionDefinitions

          public java.util.List<FunctionDefinition> getFunctionDefinitions()

      Description copied from interface: `Context`
      Returns list of functions.
      Specified by:
        `getFunctionDefinitions` in interface `Context<C extends Context>`

    - #### getFunctionDefinitions

          public java.util.List<FunctionDefinition> getFunctionDefinitions(CallerController caller,
                                                                           java.lang.String group)

      Description copied from interface: `Context`
      Returns list of functions belonging to `group` that are available for specified `CallerController`.
      Specified by:
        `getFunctionDefinitions` in interface `Context<C extends Context>`

    - #### getFunctionDefinitions

          public java.util.List<FunctionDefinition> getFunctionDefinitions(java.lang.String group)

      Description copied from interface: `Context`
      Returns list of functions belonging to `group`.
      Specified by:
        `getFunctionDefinitions` in interface `Context<C extends Context>`

    - #### getChildrenLock

          protected java.util.concurrent.locks.ReentrantReadWriteLock getChildrenLock()

    - #### getType

          public java.lang.String getType()

      Description copied from interface: `Context`
      Returns context type.
      Specified by:
        `getType` in interface `Context<C extends Context>`

    - #### isPermissionCheckingEnabled

          public boolean isPermissionCheckingEnabled()

    - #### getIconId

          public java.lang.String getIconId()

      Description copied from interface: `Context`
      Returns context icon ID.
      Specified by:
        `getIconId` in interface `Context<C extends Context>`

    - #### getIndex

          public java.lang.Integer getIndex()

      Description copied from interface: `Context`
      Returns context comparison index or NULL if index is not defined.
      Specified by:
        `getIndex` in interface `Context<C extends Context>`

    - #### getGroup

          public java.lang.String getGroup()

      Description copied from interface: `Context`
      Returns context group name of NULL if context does not belong to a group.
      Specified by:
        `getGroup` in interface `Context<C extends Context>`

    - #### getLocalRoot

          public java.lang.String getLocalRoot(boolean withParent)

      Description copied from interface: `Context`
      Returns path of the root context. In distributed environment, returns path of the root context in remote (mounted) subtree.
      Specified by:
        `getLocalRoot` in interface `Context<C extends Context>`

    - #### isProxy

          public boolean isProxy()

      Description copied from interface: `Context`
      Returns true if context is a remote context's proxy.
      Specified by:
        `isProxy` in interface `Context<C extends Context>`

    - #### isDistributed

          public boolean isDistributed()

      Description copied from interface: `Context`
      Returns true if context has a remote peer in the distributed architecture.
      Specified by:
        `isDistributed` in interface `Context<C extends Context>`

    - #### isContainer

          public boolean isContainer()

      Description copied from interface: `Context`
      Returns true if context is container.
      Specified by:
        `isContainer` in interface `Context<C extends Context>`

    - #### getPeerRoot

          public java.lang.String getPeerRoot()

      Description copied from interface: `Context`
      When a certain context subtree from one server is connected to another server, this method will return the remote path of this subtree's root context. If current context doesn't have a remote peer, this method returns null.
      Specified by:
        `getPeerRoot` in interface `Context<C extends Context>`

    - #### getRemoteRoot

          public java.lang.String getRemoteRoot()

      Description copied from interface: `Context`
      Returns path of remote server's root context within a distributed connection.
      Specified by:
        `getRemoteRoot` in interface `Context<C extends Context>`

    - #### getRemotePath

          public java.lang.String getRemotePath()

      Description copied from interface: `Context`
      In distributed environment, returns path of the context on the server where it's actually defined.
      Specified by:
        `getRemotePath` in interface `Context<C extends Context>`

    - #### getPeerPath

          public java.lang.String getPeerPath()

      Description copied from interface: `Context`
      In distributed environment, returns path of the context on the server immediately connected to current server (current server's peer).
      Specified by:
        `getPeerPath` in interface `Context<C extends Context>`

    - #### getLocalPrimaryRoot

          public java.lang.String getLocalPrimaryRoot()

      Description copied from interface: `Context`
      In distributed environment, returns path of the primary mount context in local tree.
      Specified by:
        `getLocalPrimaryRoot` in interface `Context<C extends Context>`

    - #### setType

          public void setType(java.lang.String type)

    - #### setPermissionCheckingEnabled

          protected void setPermissionCheckingEnabled(boolean permissionCheckingEnabled)

    - #### setIconId

          protected void setIconId(java.lang.String iconId)

    - #### setIndex

          @Deprecated
          public void setIndex(java.lang.Integer index)

      Deprecated. Use ContextSortingHelper class for set tree context hierarchy

    - #### setGroup

          public void setGroup(java.lang.String group)

    - #### getEventDefinitions

          public java.util.List<EventDefinition> getEventDefinitions(CallerController caller)

      Description copied from interface: `Context`
      Returns list of events available for specified `CallerController`.
      Specified by:
        `getEventDefinitions` in interface `Context<C extends Context>`

    - #### getEventDefinitions

          public java.util.List<EventDefinition> getEventDefinitions(CallerController caller,
                                                                     boolean includeHidden)

      Description copied from interface: `Context`
      Returns list of events.
      Specified by:
        `getEventDefinitions` in interface `Context<C extends Context>`

    - #### getEventDefinitions

          public java.util.List<EventDefinition> getEventDefinitions()

      Description copied from interface: `Context`
      Returns list of events.
      Specified by:
        `getEventDefinitions` in interface `Context<C extends Context>`

    - #### getEventDefinitions

          public java.util.List<EventDefinition> getEventDefinitions(CallerController caller,
                                                                     java.lang.String group)

      Description copied from interface: `Context`
      Returns list of events belonging to `group` that are available for specified `CallerController`.
      Specified by:
        `getEventDefinitions` in interface `Context<C extends Context>`

    - #### getEventDefinitions

          public java.util.List<EventDefinition> getEventDefinitions(java.lang.String group)

      Description copied from interface: `Context`
      Returns list of events belonging to `group`.
      Specified by:
        `getEventDefinitions` in interface `Context<C extends Context>`

    - #### getActionDefinition

          public ActionDefinition getActionDefinition(java.lang.String name)

      Description copied from interface: `Context`
      Returns action definition by name.
      Specified by:
        `getActionDefinition` in interface `Context<C extends Context>`
      Parameters:
        `name` - Name of action

    - #### getActionDefinition

          public ActionDefinition getActionDefinition(java.lang.String name,
                                                      CallerController caller)

      Description copied from interface: `Context`
      Returns action definition by name.
      Specified by:
        `getActionDefinition` in interface `Context<C extends Context>`
      Parameters:
        `name` - Name of action
        `caller` - Caller controller

    - #### getDefaultActionDefinition

          public ActionDefinition getDefaultActionDefinition(CallerController caller)

      Description copied from interface: `Context`
      Returns default action definition or NULL if there is no default action or it's not available to the caller.
      Specified by:
        `getDefaultActionDefinition` in interface `Context<C extends Context>`
      Parameters:
        `caller` - Caller controller

    - #### getActionDefinitions

          public java.util.List<ActionDefinition> getActionDefinitions(CallerController caller)

      Description copied from interface: `Context`
      Returns action definitions that are accessible for the caller.
      Specified by:
        `getActionDefinitions` in interface `Context<C extends Context>`
      Parameters:
        `caller` - Caller controller

    - #### addActionDefinition

          public void addActionDefinition(ActionDefinition def)

      Description copied from interface: `Context`
      Add a new action definition to the context.
      Specified by:
        `addActionDefinition` in interface `Context<C extends Context>`
      Parameters:
        `def` - ActionDefinition to add

    - #### getActionDefinitions

          public java.util.List<ActionDefinition> getActionDefinitions(CallerController caller,
                                                                       boolean includeHidden)

      Description copied from interface: `Context`
      Returns action definitions.
      Specified by:
        `getActionDefinitions` in interface `Context<C extends Context>`

    - #### getActionDefinitions

          public java.util.List<ActionDefinition> getActionDefinitions()

      Description copied from interface: `Context`
      Returns action definitions.
      Specified by:
        `getActionDefinitions` in interface `Context<C extends Context>`

    - #### applyCachedFormat

          protected void applyCachedFormat(java.util.function.Supplier<TableFormat> formatGetter,
                                           java.util.function.Consumer<TableFormat> formatSetter)

      Extracts table format with given getter and puts it into current format cache. If the cache already contains such format, replaces the format with cached one by means of given format setter.
      Parameters:
        `formatGetter` - a method link to extract the format (like `VariableDefinition.getFormat()`)
        `formatSetter` - a method link to replace the format (like `VariableDefinition.setFormat(com.tibbo.aggregate.common.datatable.TableFormat)`)

    - #### removeActionDefinition

          public void removeActionDefinition(java.lang.String name)

      Description copied from interface: `Context`
      Remove an action definition from the context.
      Specified by:
        `removeActionDefinition` in interface `Context<C extends Context>`
      Parameters:
        `name` - Name of action to remove

    - #### actDefFromDataRecord

          public ActionDefinition actDefFromDataRecord(DataRecord rec)

    - #### executeDefaultGetter

          public DataTable executeDefaultGetter(java.lang.String name,
                                                CallerController caller)
                                         throws ContextException

      Throws:
        `ContextException`

    - #### executeDefaultGetter

          public DataTable executeDefaultGetter(java.lang.String name,
                                                CallerController caller,
                                                boolean check)
                                         throws ContextException

      Throws:
        `ContextException`

    - #### executeDefaultGetter

          public DataTable executeDefaultGetter(java.lang.String name,
                                                CallerController caller,
                                                boolean check,
                                                boolean createDefault)
                                         throws ContextException

      Throws:
        `ContextException`

    - #### executeDefaultGetterImpl

          protected DataTable executeDefaultGetterImpl(VariableDefinition vd,
                                                       CallerController caller)
                                                throws ContextException

      Throws:
        `ContextException`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### equals

          public boolean equals(java.lang.Object obj)

      Overrides:
        `equals` in class `java.lang.Object`

    - #### getVariable

          public DataTable getVariable(java.lang.String name,
                                       CallerController caller,
                                       RequestController request)
                                throws ContextException

      Description copied from interface: `Context`
      Gets variable from context and returns its value. The value is immutable and will generate `IllegalStateException` on every change.
      Specified by:
        `getVariable` in interface `Context<C extends Context>`
      Throws:
        `ContextException`

    - #### getVariable

          public DataTable getVariable(java.lang.String name,
                                       CallerController caller)
                                throws ContextException

      Description copied from interface: `Context`
      Gets variable from context and returns its value. The value is immutable and will generate `IllegalStateException` on every change.
      Specified by:
        `getVariable` in interface `Context<C extends Context>`
      Throws:
        `ContextException`

    - #### getVariable

          public DataTable getVariable(java.lang.String name)
                                throws ContextException

      Description copied from interface: `Context`
      Gets variable from context and returns its value. The value is immutable and will generate `IllegalStateException` on every change.
      Specified by:
        `getVariable` in interface `Context<C extends Context>`
      Throws:
        `ContextException`

    - #### getVariableClone

          public DataTable getVariableClone(java.lang.String name,
                                            CallerController caller)
                                     throws ContextException

      Description copied from interface: `Context`
      Gets variable from context and returns its value. The value is mutable. Method has lower performance comparing to 'getVariable'.
      Specified by:
        `getVariableClone` in interface `Context<C extends Context>`
      Throws:
        `ContextException`

    - #### getVariableImpl

          protected DataTable getVariableImpl(VariableDefinition def,
                                              CallerController caller,
                                              RequestController request)
                                       throws ContextException

      Throws:
        `ContextException`

    - #### getVariableObject

          public java.lang.Object getVariableObject(java.lang.String name,
                                                    CallerController caller)

      Description copied from interface: `Context`
      Returns value of variable as bean or list of beans.
      Specified by:
        `getVariableObject` in interface `Context<C extends Context>`

    - #### variableUpdated

          protected void variableUpdated(VariableDefinition def,
                                         CallerController caller,
                                         RequestController request,
                                         DataTable value,
                                         DataTable valueOld)
                                  throws ContextException

      Throws:
        `ContextException`

    - #### fireUpdatedEvent

          protected void fireUpdatedEvent(VariableDefinition def,
                                          CallerController caller,
                                          RequestController request,
                                          DataTable value,
                                          DataTable valueOld)
                                   throws ContextException

      Throws:
        `ContextException`

    - #### fireChangeEvent

          public void fireChangeEvent(VariableDefinition def,
                                      CallerController caller,
                                      java.util.Date timestamp,
                                      DataTable value)

    - #### isAllowUpdatedEvents

          protected boolean isAllowUpdatedEvents(VariableDefinition def)

    - #### setupVariables

          protected void setupVariables()
                                 throws ContextException

      Throws:
        `ContextException`

    - #### getDefaultValue

          public DataTable getDefaultValue(VariableDefinition def)

    - #### executeDefaultSetter

          public void executeDefaultSetter(java.lang.String name,
                                           CallerController caller,
                                           DataTable value)
                                    throws ContextException

      Throws:
        `ContextException`

    - #### executeDefaultSetter

          public void executeDefaultSetter(VariableDefinition def,
                                           CallerController caller,
                                           DataTable value)
                                    throws ContextException

      Throws:
        `ContextException`

    - #### executeDefaultSetterImpl

          protected void executeDefaultSetterImpl(VariableDefinition vd,
                                                  CallerController caller,
                                                  DataTable value)
                                           throws ContextException

      Throws:
        `ContextException`

    - #### setVariable

          public void setVariable(java.lang.String name,
                                  CallerController caller,
                                  RequestController request,
                                  DataTable value)
                           throws ContextException

      Description copied from interface: `Context`
      Sets context variable to specified `value`.
      Specified by:
        `setVariable` in interface `Context<C extends Context>`
      Throws:
        `ContextException`

    - #### setVariable

          public void setVariable(java.lang.String name,
                                  CallerController caller,
                                  DataTable value)
                           throws ContextException

      Description copied from interface: `Context`
      Sets context variable to specified `value`.
      Specified by:
        `setVariable` in interface `Context<C extends Context>`
      Throws:
        `ContextException`

    - #### setVariable

          public void setVariable(java.lang.String name,
                                  DataTable value)
                           throws ContextException

      Description copied from interface: `Context`
      Sets context variable to specified `value`.
      Specified by:
        `setVariable` in interface `Context<C extends Context>`
      Throws:
        `ContextException`

    - #### setVariable

          public void setVariable(java.lang.String name,
                                  CallerController caller,
                                  java.lang.Object... value)
                           throws ContextException

      Description copied from interface: `Context`
      Sets context variable to specified `value`.
      Specified by:
        `setVariable` in interface `Context<C extends Context>`
      Throws:
        `ContextException`

    - #### setVariable

          public void setVariable(java.lang.String name,
                                  java.lang.Object... value)
                           throws ContextException

      Description copied from interface: `Context`
      Sets context variable to specified `value`.
      Specified by:
        `setVariable` in interface `Context<C extends Context>`
      Throws:
        `ContextException`

    - #### setVariableImpl

          protected boolean setVariableImpl(VariableDefinition def,
                                            CallerController caller,
                                            RequestController request,
                                            DataTable value)
                                     throws ContextException

      Throws:
        `ContextException`

    - #### isAllowSetterExecution

          protected boolean isAllowSetterExecution(VariableDefinition data,
                                                   RequestController request,
                                                   DataTable value)
                                            throws ContextException

      Throws:
        `ContextException`

    - #### setVariableField

          public boolean setVariableField(java.lang.String variable,
                                          java.lang.String field,
                                          java.lang.Object value,
                                          CallerController cc)
                                   throws ContextException

      Description copied from interface: `Context`
      Gets variable, updates field value in the first record, and sets variable.
      Specified by:
        `setVariableField` in interface `Context<C extends Context>`
      Throws:
        `ContextException`

    - #### setVariableField

          public boolean setVariableField(java.lang.String variable,
                                          java.lang.String field,
                                          int record,
                                          java.lang.Object value,
                                          CallerController cc,
                                          RequestController request)
                                   throws ContextException

      Specified by:
        `setVariableField` in interface `Context<C extends Context>`
      Throws:
        `ContextException`

    - #### setVariableField

          public void setVariableField(java.lang.String variable,
                                       java.lang.String field,
                                       java.lang.Object value,
                                       java.lang.String compareField,
                                       java.lang.Object compareValue,
                                       CallerController cc)
                                throws ContextException

      Description copied from interface: `Context`
      Gets variable, updates field value in the records for those value of compareField equals compareValue, and sets variable.
      Specified by:
        `setVariableField` in interface `Context<C extends Context>`
      Throws:
        `ContextException`

    - #### addVariableRecord

          public void addVariableRecord(java.lang.String variable,
                                        CallerController cc,
                                        DataRecord record)
                                 throws ContextException

      Throws:
        `ContextException`

    - #### addVariableRecord

          public void addVariableRecord(java.lang.String variable,
                                        CallerController cc,
                                        java.lang.Object... recordData)
                                 throws ContextException

      Throws:
        `ContextException`

    - #### removeVariableRecords

          public void removeVariableRecords(java.lang.String variable,
                                            CallerController cc,
                                            java.lang.String field,
                                            java.lang.Object value)
                                     throws ContextException

      Throws:
        `ContextException`

    - #### callFunction

          protected DataTable callFunction(FunctionDefinition def,
                                           CallerController caller,
                                           RequestController request,
                                           DataTable parameters)
                                    throws ContextException

      Throws:
        `ContextException`

    - #### setupFunctions

          protected void setupFunctions()
                                 throws ContextException

      Throws:
        `ContextException`

    - #### callFunction

          public DataTable callFunction(java.lang.String name,
                                        CallerController caller,
                                        RequestController request,
                                        DataTable parameters)
                                 throws ContextException

      Description copied from interface: `Context`
      Executes context function with specified `parameters` and returns its output.
      Specified by:
        `callFunction` in interface `Context<C extends Context>`
      Throws:
        `ContextException`

    - #### callFunction

          public DataTable callFunction(java.lang.String name,
                                        CallerController caller,
                                        DataTable parameters)
                                 throws ContextException

      Description copied from interface: `Context`
      Executes context function with specified `parameters` and returns its output.
      Specified by:
        `callFunction` in interface `Context<C extends Context>`
      Throws:
        `ContextException`

    - #### callFunction

          public DataTable callFunction(java.lang.String name,
                                        DataTable parameters)
                                 throws ContextException

      Description copied from interface: `Context`
      Executes context function with specified `parameters` and returns its output.
      Specified by:
        `callFunction` in interface `Context<C extends Context>`
      Throws:
        `ContextException`

    - #### callFunction

          public DataTable callFunction(java.lang.String name)
                                 throws ContextException

      Description copied from interface: `Context`
      Executes context function with specified `parameters` and returns its output.
      Specified by:
        `callFunction` in interface `Context<C extends Context>`
      Throws:
        `ContextException`

    - #### callFunction

          public DataTable callFunction(java.lang.String name,
                                        CallerController caller)
                                 throws ContextException

      Description copied from interface: `Context`
      Executes context function with specified `parameters` and returns its output.
      Specified by:
        `callFunction` in interface `Context<C extends Context>`
      Throws:
        `ContextException`

    - #### callFunction

          public DataTable callFunction(java.lang.String name,
                                        CallerController caller,
                                        java.lang.Object... parameters)
                                 throws ContextException

      Description copied from interface: `Context`
      Executes context function with specified `parameters` and returns its output.
      Specified by:
        `callFunction` in interface `Context<C extends Context>`
      Throws:
        `ContextException`

    - #### callFunction

          public DataTable callFunction(java.lang.String name,
                                        java.lang.Object... parameters)
                                 throws ContextException

      Description copied from interface: `Context`
      Executes context function with specified `parameters` and returns its output.
      Specified by:
        `callFunction` in interface `Context<C extends Context>`
      Throws:
        `ContextException`

    - #### callFunctionImpl

          protected DataTable callFunctionImpl(FunctionDefinition def,
                                               CallerController caller,
                                               RequestController request,
                                               DataTable parameters)
                                        throws ContextException

      Throws:
        `ContextException`

    - #### addVariableDefinition

          public void addVariableDefinition(VariableDefinition def)

      Description copied from interface: `Context`
      Adds variable definition to this context.
      Specified by:
        `addVariableDefinition` in interface `Context<C extends Context>`

    - #### fireVariableAdded

          protected void fireVariableAdded(VariableDefinition def)

    - #### removeVariableDefinition

          public void removeVariableDefinition(java.lang.String name)

      Description copied from interface: `Context`
      Removes variable definition from this context.
      Specified by:
        `removeVariableDefinition` in interface `Context<C extends Context>`

    - #### updateVariableDefinitions

          public java.util.List<VariableDefinition> updateVariableDefinitions(java.util.Map<java.lang.String,VariableDefinition> source,
                                                                              java.lang.String baseGroup,
                                                                              boolean skipRemoval,
                                                                              boolean removeValues,
                                                                              java.lang.Object owner)

      Specified by:
        `updateVariableDefinitions` in interface `Context<C extends Context>`

    - #### removeValues

          protected void removeValues(VariableDefinition vd)

    - #### onIllegalDefinitionUpdated

          protected void onIllegalDefinitionUpdated(java.lang.String definitionName)

    - #### addFunctionDefinition

          public void addFunctionDefinition(FunctionDefinition def)

      Description copied from interface: `Context`
      Adds function definition to this context.
      Specified by:
        `addFunctionDefinition` in interface `Context<C extends Context>`

    - #### fireFunctionAdded

          protected void fireFunctionAdded(FunctionDefinition def)

    - #### removeFunctionDefinition

          public void removeFunctionDefinition(java.lang.String name)

      Description copied from interface: `Context`
      Removes function definition from this context.
      Specified by:
        `removeFunctionDefinition` in interface `Context<C extends Context>`

    - #### updateFunctionDefinitions

          public java.util.List<FunctionDefinition> updateFunctionDefinitions(java.util.Map<java.lang.String,Pair<FunctionDefinition,java.lang.Boolean>> source,
                                                                              java.lang.String baseGroup,
                                                                              boolean skipRemoval,
                                                                              java.lang.Object owner)

      Specified by:
        `updateFunctionDefinitions` in interface `Context<C extends Context>`

    - #### addEventDefinition

          public void addEventDefinition(EventDefinition def)

      Description copied from interface: `Context`
      Adds event definition to this context.
      Specified by:
        `addEventDefinition` in interface `Context<C extends Context>`

    - #### updateFunctionAndAction

          protected boolean updateFunctionAndAction(FunctionDefinition fd,
                                                    boolean processAction,
                                                    java.lang.Object owner)

    - #### updateEventDefinitions

          public java.util.List<EventDefinition> updateEventDefinitions(java.util.Map<java.lang.String,EventDefinition> source,
                                                                        java.lang.String baseGroup,
                                                                        boolean skipRemoval,
                                                                        java.lang.Object owner)

      Specified by:
        `updateEventDefinitions` in interface `Context<C extends Context>`

    - #### fireEventAdded

          protected void fireEventAdded(EventDefinition def)

    - #### removeEventDefinition

          public void removeEventDefinition(java.lang.String name)

      Description copied from interface: `Context`
      Removes event definition from this context.
      Specified by:
        `removeEventDefinition` in interface `Context<C extends Context>`

    - #### getVariableData

          public VariableData getVariableData(java.lang.String name)

      Description copied from interface: `Context`
      Returns data of variable with specified name.
      Specified by:
        `getVariableData` in interface `Context<C extends Context>`

    - #### addAlias

          public void addAlias(int entityType,
                               java.lang.String aliasName,
                               java.lang.String name)

      Specified by:
        `addAlias` in interface `Context<C extends Context>`

    - #### getVariableDefinition

          public VariableDefinition getVariableDefinition(java.lang.String name)

      Description copied from interface: `Context`
      Returns definition of variable with specified name.
      Specified by:
        `getVariableDefinition` in interface `Context<C extends Context>`

    - #### getVariableDefinition

          public VariableDefinition getVariableDefinition(java.lang.String name,
                                                          CallerController caller)

      Description copied from interface: `Context`
      Returns definition of variable with specified name if it's accessible by caller controller.
      Specified by:
        `getVariableDefinition` in interface `Context<C extends Context>`

    - #### getFunctionData

          public FunctionData getFunctionData(java.lang.String name)

      Description copied from interface: `Context`
      Returns data of function with specified name.
      Specified by:
        `getFunctionData` in interface `Context<C extends Context>`

    - #### getFunctionDefinition

          public FunctionDefinition getFunctionDefinition(java.lang.String name)

      Description copied from interface: `Context`
      Returns definition of function with specified name.
      Specified by:
        `getFunctionDefinition` in interface `Context<C extends Context>`

    - #### getFunctionDefinition

          public FunctionDefinition getFunctionDefinition(java.lang.String name,
                                                          CallerController caller)

      Description copied from interface: `Context`
      Returns definition of function with specified name if it's accessible by caller controller.
      Specified by:
        `getFunctionDefinition` in interface `Context<C extends Context>`

    - #### getEventData

          public EventData getEventData(java.lang.String name)

      Description copied from interface: `Context`
      Returns `EventData` of event with specified name.
      Specified by:
        `getEventData` in interface `Context<C extends Context>`

    - #### getEventDefinition

          public EventDefinition getEventDefinition(java.lang.String name)

      Description copied from interface: `Context`
      Returns definition of event with specified name.
      Specified by:
        `getEventDefinition` in interface `Context<C extends Context>`

    - #### getEventDefinition

          public EventDefinition getEventDefinition(java.lang.String name,
                                                    CallerController caller)

      Description copied from interface: `Context`
      Returns definition of event with specified name if it's accessible by caller controller.
      Specified by:
        `getEventDefinition` in interface `Context<C extends Context>`

    - #### setupEvents

          protected void setupEvents()

    - #### postEvent

          protected void postEvent(Event ev,
                                   EventDefinition ed,
                                   CallerController caller,
                                   FireEventRequestController request)
                            throws ContextException

      Throws:
        `ContextException`

    - #### updateEvent

          protected void updateEvent(Event ev,
                                     EventDefinition ed,
                                     CallerController caller,
                                     FireEventRequestController request)
                              throws ContextException

      Throws:
        `ContextException`

    - #### fireEvent

          protected Event fireEvent(EventDefinition ed,
                                    DataTable data,
                                    int level,
                                    java.lang.Long id,
                                    java.util.Date creationtime,
                                    java.lang.Integer listener,
                                    CallerController caller,
                                    FireEventRequestController request,
                                    Permissions permissions)

    - #### fireEvent

          protected Event fireEvent(Event event)

    - #### fireEvent

          public Event fireEvent(java.lang.String name,
                                 FireEventRequestController request,
                                 java.lang.Object... data)

      Specified by:
        `fireEvent` in interface `Context<C extends Context>`

    - #### fireEvent

          protected Event fireEvent(EventDefinition ed,
                                    Event event,
                                    java.lang.Integer listener,
                                    CallerController caller,
                                    FireEventRequestController request)

    - #### fireEvent

          public Event fireEvent(java.lang.String name,
                                 int level,
                                 CallerController caller,
                                 FireEventRequestController request,
                                 Permissions permissions,
                                 DataTable data)

    - #### fireEvent

          public Event fireEvent(java.lang.String name,
                                 DataTable data,
                                 int level,
                                 java.lang.Long id,
                                 java.util.Date creationtime,
                                 java.lang.Integer listener,
                                 CallerController caller,
                                 FireEventRequestController request)

      Description copied from interface: `Context`
      Fires context event.
      Specified by:
        `fireEvent` in interface `Context<C extends Context>`
      Returns:
        Event object or null if event was suppressed by context.

    - #### fireEvent

          public Event fireEvent(java.lang.String name,
                                 DataTable data)

      Description copied from interface: `Context`
      Fires context event.
      Specified by:
        `fireEvent` in interface `Context<C extends Context>`
      Returns:
        Event object or null if event was suppressed by context.

    - #### fireEvent

          public Event fireEvent(java.lang.String name,
                                 CallerController caller,
                                 DataTable data)

      Description copied from interface: `Context`
      Fires context event.
      Specified by:
        `fireEvent` in interface `Context<C extends Context>`
      Returns:
        Event object or null if event was suppressed by context.

    - #### fireEvent

          public Event fireEvent(java.lang.String name,
                                 int level,
                                 DataTable data)

      Description copied from interface: `Context`
      Fires context event.
      Specified by:
        `fireEvent` in interface `Context<C extends Context>`
      Returns:
        Event object or null if event was suppressed by context.

    - #### fireEvent

          public Event fireEvent(java.lang.String name,
                                 int level,
                                 CallerController caller,
                                 DataTable data)

      Description copied from interface: `Context`
      Fires context event.
      Specified by:
        `fireEvent` in interface `Context<C extends Context>`
      Returns:
        Event object or null if event was suppressed by context.

    - #### fireEvent

          public Event fireEvent(java.lang.String name,
                                 int level,
                                 CallerController caller,
                                 FireEventRequestController request,
                                 DataTable data)

      Description copied from interface: `Context`
      Fires context event.
      Specified by:
        `fireEvent` in interface `Context<C extends Context>`
      Returns:
        Event object or null if event was suppressed by context.

    - #### fireEvent

          public Event fireEvent(java.lang.String name)

      Description copied from interface: `Context`
      Fires context event.
      Specified by:
        `fireEvent` in interface `Context<C extends Context>`
      Returns:
        Event object or null if event was suppressed by context.

    - #### fireEvent

          public Event fireEvent(java.lang.String name,
                                 CallerController caller)

      Description copied from interface: `Context`
      Fires context event.
      Specified by:
        `fireEvent` in interface `Context<C extends Context>`
      Returns:
        Event object or null if event was suppressed by context.

    - #### fireEvent

          public Event fireEvent(java.lang.String name,
                                 java.lang.Object... data)

      Description copied from interface: `Context`
      Fires context event.
      Specified by:
        `fireEvent` in interface `Context<C extends Context>`
      Returns:
        Event object or null if event was suppressed by context.

    - #### getEventProcessingRule

          protected EventProcessingRule getEventProcessingRule(Event event)

    - #### processBindings

          protected void processBindings(Event event)

    - #### getEventProcessingCallerController

          protected CallerController getEventProcessingCallerController()

    - #### getEventHistory

          public java.util.List<Event> getEventHistory(java.lang.String name)

      Description copied from interface: `Context`
      Returns in-memory event history.
      Specified by:
        `getEventHistory` in interface `Context<C extends Context>`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### toDetailedString

          public java.lang.String toDetailedString()

      Description copied from interface: `Context`
      Returns context detailed description that includes description and path.
      Specified by:
        `toDetailedString` in interface `Context<C extends Context>`

    - #### accept

          public void accept(ContextVisitor visitor)
                      throws ContextException

      Description copied from interface: `Context`
      Accepts context visitor, i.e. calls visitor.visit(this).
      Specified by:
        `accept` in interface `Context<C extends Context>`
      Throws:
        `ContextException`

    - #### getChangeEventDefinition

          protected EventDefinition getChangeEventDefinition()

    - #### getVvariables

          public DataTable getVvariables(VariableDefinition def,
                                         CallerController caller,
                                         RequestController request)
                                  throws ContextException

      Throws:
        `ContextException`

    - #### encodeFormat

          protected java.lang.String encodeFormat(TableFormat format,
                                                  CallerController caller)

    - #### decodeFormat

          protected TableFormat decodeFormat(java.lang.String source,
                                             CallerController caller)

    - #### obtainFormatCache

          protected java.util.Optional<FormatCache> obtainFormatCache()

      Returns:
        format cache optional taken from current `contextManager`

    - #### varDefToDataRecord

          public DataRecord varDefToDataRecord(VariableDefinition vd)

    - #### varDefToDataRecord

          protected DataRecord varDefToDataRecord(VariableDefinition vd,
                                                  CallerController caller)

    - #### varDefFromDataRecord

          public VariableDefinition varDefFromDataRecord(DataRecord rec)

    - #### getVfunctions

          public DataTable getVfunctions(VariableDefinition def,
                                         CallerController caller,
                                         RequestController request)
                                  throws ContextException

      Throws:
        `ContextException`

    - #### funcDefToDataRecord

          public DataRecord funcDefToDataRecord(FunctionDefinition fd)

    - #### funcDefToDataRecord

          protected DataRecord funcDefToDataRecord(FunctionDefinition fd,
                                                   CallerController caller)

    - #### funcDefFromDataRecord

          public FunctionDefinition funcDefFromDataRecord(DataRecord rec)

    - #### getVevents

          public DataTable getVevents(VariableDefinition def,
                                      CallerController caller,
                                      RequestController request)
                               throws ContextException

      Throws:
        `ContextException`

    - #### evtDefToDataRecord

          public DataRecord evtDefToDataRecord(EventDefinition ed)

    - #### evtDefToDataRecord

          protected DataRecord evtDefToDataRecord(EventDefinition ed,
                                                  CallerController caller)

    - #### evtDefFromDataRecord

          public EventDefinition evtDefFromDataRecord(DataRecord rec)

    - #### getVactions

          public DataTable getVactions(VariableDefinition def,
                                       CallerController caller,
                                       RequestController request)
                                throws ContextException

      Throws:
        `ContextException`

    - #### actDefToDataRecord

          public DataRecord actDefToDataRecord(ActionDefinition def)

    - #### executeTasks

          protected void executeTasks(java.util.List<java.util.concurrent.Callable<java.lang.Object>> tasks)

    - #### executeTasks

          protected void executeTasks(java.util.List<java.util.concurrent.Callable<java.lang.Object>> tasks,
                                      double loadFactor)

    - #### executeTasksConcurrently

          protected void executeTasksConcurrently(java.util.List<java.util.concurrent.Callable<java.lang.Object>> tasks,
                                                  double loadFactor)
                                           throws java.lang.Exception

      Tries to utilize underlying `ContextOperationExecutor` as much as possible but without occupying 100% of its threads. This is important to prevent deadlocks which may arise if some tasks being executed need to wait for other children tasks that cannot be finished due to pool overwhelming. The method prevents it by always leaving some part of the threads free (depending on their number and `loadFactor` value) and executing separate tasks (not bunches) right in the current thread.
      Parameters:
        `tasks` - a list of tasks to be executed
        `loadFactor` - a ratio of threads that can be utilized by this invocation, should be between 0.1 and 0.9
      Throws:
        `java.lang.Exception` - when concurrent execution is interrupted or single task invocation fails

    - #### enableStatus

          protected void enableStatus()
                               throws ContextException

      Throws:
        `ContextException`

    - #### getStatus

          public ContextStatus getStatus()

      Description copied from interface: `Context`
      Returns context status or null if status is not enabled;
      Specified by:
        `getStatus` in interface `Context<C extends Context>`

    - #### setStatus

          public void setStatus(int status,
                                java.lang.String comment)

    - #### fireStatusChanged

          protected void fireStatusChanged(int status,
                                           java.lang.String comment,
                                           int oldStatus)

    - #### enableVariableStatuses

          protected void enableVariableStatuses(boolean persistent)

    - #### ensureVariableStatuses

          protected void ensureVariableStatuses()
                                         throws ContextException

      Throws:
        `ContextException`

    - #### isBelongedToTheGroup

          protected boolean isBelongedToTheGroup(java.lang.String targetGroup,
                                                 java.lang.String entityGroup)

    - #### fetchVariableStatuses

          protected DataTable fetchVariableStatuses()
                                             throws ContextException

      Throws:
        `ContextException`

    - #### updateVariableStatus

          public void updateVariableStatus(java.lang.String variable,
                                           VariableStatus status,
                                           boolean persistent)
                                    throws ContextException

      Throws:
        `ContextException`

    - #### clearVariableStatuses

          protected void clearVariableStatuses()
                                        throws ContextException

      Throws:
        `ContextException`

    - #### saveVariableStatuses

          protected void saveVariableStatuses()
                                       throws ContextException

      Throws:
        `ContextException`

    - #### persistVariableStatuses

          protected void persistVariableStatuses(DataTable statuses)
                                          throws ContextException

      Throws:
        `ContextException`

    - #### getVariableStatus

          public VariableStatus getVariableStatus(VariableDefinition variableDefinition)
                                           throws ContextException

      Throws:
        `ContextException`

    - #### getVchildren

          public DataTable getVchildren(VariableDefinition def,
                                        CallerController caller,
                                        RequestController request)
                                 throws ContextException

      Throws:
        `ContextException`

    - #### getVinfo

          public DataTable getVinfo(VariableDefinition def,
                                    CallerController caller,
                                    RequestController request)
                             throws ContextException

      Throws:
        `ContextException`

    - #### createContextInfoTable

          protected DataTable createContextInfoTable()

    - #### callFgetCopyData

          public DataTable callFgetCopyData(FunctionDefinition def,
                                            CallerController caller,
                                            RequestController request,
                                            DataTable parameters)
                                     throws ContextException

      Throws:
        `ContextException`

    - #### callFcopy

          public DataTable callFcopy(FunctionDefinition def,
                                     CallerController caller,
                                     RequestController request,
                                     DataTable parameters)
                              throws ContextException

      Throws:
        `ContextException`

    - #### callFupdateVariable

          public DataTable callFupdateVariable(FunctionDefinition def,
                                               CallerController caller,
                                               RequestController request,
                                               DataTable parameters)
                                        throws ContextException

      Throws:
        `ContextException`

    - #### replicateVariableOnCopy

          public java.util.Set<java.lang.String> replicateVariableOnCopy(java.lang.String variableName,
                                                                         DataTable variableValue,
                                                                         DataTable targetValue,
                                                                         java.util.List<java.lang.String> fields,
                                                                         CallerController caller)

    - #### callFcopyToChildren

          public DataTable callFcopyToChildren(FunctionDefinition def,
                                               CallerController caller,
                                               RequestController request,
                                               DataTable parameters)
                                        throws ContextException

      Throws:
        `ContextException`

    - #### copyTo

          protected DataTable copyTo(FunctionDefinition def,
                                     CallerController caller,
                                     RequestController request,
                                     DataTable parameters,
                                     java.util.List<C> children)

    - #### callFgetAliases

          public DataTable callFgetAliases(FunctionDefinition def,
                                           CallerController caller,
                                           RequestController request,
                                           DataTable parameters)
                                    throws ContextException

      Throws:
        `ContextException`

    - #### callFfireContextEvent

          public DataTable callFfireContextEvent(FunctionDefinition def,
                                                 CallerController caller,
                                                 RequestController request,
                                                 DataTable parameters)
                                          throws ContextException

      Throws:
        `ContextException`

    - #### isDebuggingEvaluations

          public boolean isDebuggingEvaluations()

      Specified by:
        `isDebuggingEvaluations` in interface `EvaluationPoint`

    - #### processEvaluation

          public void processEvaluation(Evaluator evaluator,
                                        Expression expression,
                                        Reference holder,
                                        java.lang.Object result,
                                        NodeEvaluationDetails details)

      Specified by:
        `processEvaluation` in interface `EvaluationPoint`

    - #### processEvaluationError

          public void processEvaluationError(Evaluator evaluator,
                                             Expression expression,
                                             Reference holder,
                                             java.lang.Exception error,
                                             NodeEvaluationDetails details)

      Specified by:
        `processEvaluationError` in interface `EvaluationPoint`

    - #### isInstallationAllowed

          public boolean isInstallationAllowed(java.lang.String installableName)

      Description copied from interface: `Context`
      Check if an installation is permitted.
      Specified by:
        `isInstallationAllowed` in interface `Context<C extends Context>`

    - #### logAsyncSessionExecutionAction

          protected void logAsyncSessionExecutionAction(CallerController caller,
                                                        RequestController requestController,
                                                        ContextOperationType operationType,
                                                        java.lang.String entityName,
                                                        DataTable parameters,
                                                        DataTable output,
                                                        long duration)
                                                 throws ContextException

      Throws:
        `ContextException`

    - #### validateVariableValueToSet

          protected void validateVariableValueToSet(VariableDefinition variableDefinition,
                                                    DataTable value)
                                             throws ContextException

      Throws:
        `ContextException`

    - #### getVariableDataView

          protected java.util.Map<java.lang.String,VariableData> getVariableDataView()

    - #### getFunctionDataView

          protected java.util.Map<java.lang.String,FunctionData> getFunctionDataView()

    - #### getEventDataView

          protected java.util.Map<java.lang.String,EventData> getEventDataView()